#include "RAF.h"
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <fstream>
#include ".\object.h"
#include ".\blockfile\blk_file.h"
#include ".\gadget\gadget.h"


void add_fname_ext(char * _fname)
{
	strcat(_fname, ".raf");
}

void RAF::init(char *_fname, int _b_length, Cache *_c)
{
	char *fname = new char[strlen(_fname) + 10]; //allow 9 characters for extension name
	strcpy(fname, _fname);
	add_fname_ext(fname);

	FILE *fp = fopen(fname, "r");
	if (fp)
	{
		fclose(fp);
	//	printf("The file \"%s\" exists. Replace? (y/n)", fname);
	//	char c = getchar(); getchar();
	//	if (c != 'y' && c != 'Y') 
	//		error("", true);
		remove(fname);
	}

    file = new BlockFile(fname, _b_length);
    cache = _c;

	delete []fname;
}

void RAF::init_restore(char *_fname, Cache *_c)
{
	char *fname = new char[strlen(_fname) + 10]; //allow 9 characters for extension name
	strcpy(fname, _fname);
	add_fname_ext(fname);

	//--=== testing if the file exists ===--
	FILE *fp = fopen(fname, "r");
	if (!fp)
	{
		printf("RAF file %s does not exist\n", fname);
		delete []fname;
		error("", true);
	}

	fclose(fp);
	//--=== done testing the file existence ===--

    file = new BlockFile(fname, 4096);
    cache = _c;

	delete [] fname;
}

int* RAF::buid_from_array(Object ** objset, int * order)
{
	char * buffer;
	int * ptrset = new int[num_obj];


	//need to be modified
	//for(int i =0;i<num_obj;i++)
		//order[i]--;
	//	printf("%d \n",order[i]);

	int i = 0;
	int j = 0;

	
	while(j<num_obj)
	{
		buffer = new char[file->blocklength];
		i=0;
		while(i+objset[order[j]]->getsize()<file->blocklength && j< num_obj)
		{
			//printf("%d %d %f\n",j, objset[order[j]]->id, objset[order[j]]->data[0]);
			ptrset[j] = file->number * file->blocklength +i;
			objset[order[j]]->write_to_buffer(&buffer[i]);
			i += objset[order[j]]->getsize();
			j++;
			if(j>=num_obj)
				break;
		}
		file->append_block(buffer);
		delete[] buffer;
		buffer = NULL;
	}

	return ptrset;
}