#include <iostream>
#include <fstream>
#include <math.h>
#include <time.h>
#include <vector>
using namespace std;

#include "./blockfile/blk_file.h"
#include "./blockfile/cache.h"
#include "./gadget/gadget.h"
#include "./heap/binheap.h"
#include "./heap/heap.h"
#include "./rand/rand.h"
#include "./object.h"
#include "./RAF.h"
#include "./pb-tree.h"
#include <string>
double compdists =0;
double IOread =0;
double IOwrite=0;
double cc=0;
char  sss1[1000], sss2[1000];
string basep;
// Note that the id of data in the file should begin with 0
Object ** readobjects(char* filename, int num_obj, int dim)
{
    FILE *fp;
    
	int record_count = 0;
	Object ** objset =  new Object* [num_obj];
	for(int i =0;i<num_obj;i++)
	{
		objset[i] =  new Object();
	}

	if((fp = fopen(filename,"r")) == NULL)
	{
		for(int i =0;i<num_obj;i++)
			delete objset[i];
		error("Could not open the data file", TRUE);
	}
	else
	{
		while (record_count<num_obj)
		{
			if (record_count % 100 == 0)
			{
				printf("reading object %d\n", record_count);
			}
			float d;
			objset[record_count]->id = record_count;
			objset[record_count]->size = dim;
			objset[record_count]->data = new float[objset[record_count]->size];
			for (int i = 0; i < objset[record_count]->size; i++)
			{
				fscanf(fp,"%f",&d);
				objset[record_count]->data[i] = d*1000;
			}
			fscanf(fp, "\n");
			record_count++;
			
		}
	}

	return objset;
}

Object * readobjects2(char* filename, int num_obj, int dim)
{
	 FILE *fp;
    
	int record_count = 0;
	Object * objset =  new Object [num_obj];

	if((fp = fopen(filename,"r")) == NULL)
	{
			delete[] objset;
		error("Could not open the data file", TRUE);
	}
	else
	{
		while (record_count<num_obj)
		{
			if (record_count % 100 == 0)
			{
				printf("reading object %d\n", record_count);
			}
			float d;
			//fscanf(fp, "%d", &objset[record_count].id);
			objset[record_count].id = record_count;
			objset[record_count].size = dim;
			//fscanf(fp, "%d ", &objset[record_count]->length);
			objset[record_count].data = new float[objset[record_count].size];
			for (int i = 0; i < objset[record_count].size; i++)
			{
				
				fscanf(fp, "%f", &d);
				objset[record_count].data[i] = d*1000;
				//fscanf(fp, "%f", &(objset[record_count].data[i]));
				//printf("%f ",objset[record_count].data[i]);
			}
			/*
			for(int i =0;i<dim;i++)
				fscanf(fp, "%f", &d);
			//printf("\n");
			fscanf(fp, "\n");
			*/
			record_count++;			
		}
	}

	return objset;
}

clock_t bulidIndex(char* index_name, char * filename,int n_p)
{

	//pivot selection    
	PB_Tree * pb = new PB_Tree();

	//parameter settings	
	pb->eps = EPS;
	pb->num_cand=30;
	pb->num_piv=n_p;
	pb->bits = BITS;
	int num_obj = 112682; // 581012 112682
	int dim =  16;
	int keysize;
	Object * os = readobjects2(filename,num_obj,dim);
	pb->PivotSelect(os,os,num_obj/100,num_obj/100);
	//pb->PivotSelect(os,os,num_obj/10,num_obj/10,0.005);
	//pb->RPivotSelect(os,os,num_obj/100,num_obj/100);
	//pb->readptable();

	/*pb->num_piv = n_p;
	for(int i =0;i<pb->num_piv;i++)
	{
		pb->ptable[i].id= pb->cand[i].id;
		pb->ptable[i].size=pb->cand[i].size;
		pb->ptable[i].data= new float [pb->ptable[i].size];
		for(int j=0;j<pb->ptable[i].size;j++)
			pb->ptable[i].data[j]=pb->cand[i].data[j];
	}*/
	/*for(int i =0;i<pb->num_cand;i++)
		cout<<pb->cand[i].id<<" ";
	cout<<endl;
	for(int i =0;i<pb->num_piv;i++)
		cout<<pb->ptable[i].id<<" ";
	cout<<endl;*/
	IOread = IOwrite = compdists =0;
	clock_t begin;
	char st1[1000], st2[1000], st3[1000];
	sprintf(st1, "%s\\ptable.txt", basep);
	ofstream out1(st1);
	out1<<pb->num_piv<<endl;
	for(int i =0;i<pb->num_piv;i++)
	{
		out1<<pb->ptable[i].id<<" "<<pb->ptable[i].size<<" ";
		for(int j =0;j<pb->ptable[i].size;j++)
			out1<<pb->ptable[i].data[j]<<" ";
		out1<<endl;
	}
	out1.close();	

	begin= clock();
	pb->H_bulkload(os,num_obj);	
	keysize=os[0].keysize;
	delete[] os;
	cout<<"keysize:"<<keysize<<endl;
	pb->bplus = new B_Tree();
	sprintf(st2, "%s\\nasa", basep);
	pb->bplus->init(st2, 4096, NULL, keysize);
	sprintf(st3, "%s\\bulkload.txt", basep);
	pb->bplus->bulkload(st3);

	////build RAF
	
	pb->bplus->load_root();	
	B_Node * node = pb->bplus->root_ptr;
	B_Node * temp;

	while(node->level!=0)
	{
		node = node->entries[0]->get_son();
	}
	int * obj_order = new int[num_obj];
	int k =0;
	for(int i =0;i<node->num_entries;i++)
	{
		obj_order[k] = node->entries[i]->son;
		//if(obj_order[k]==1)
		//	printf("************%f\n",node->entries[i]->key[0]);
		k++;
	}
	temp = node->get_right_sibling();
	//delete node;
	while(temp != NULL)
	{
		//printf("%d %d \n", temp->level, temp->num_entries);
		node = temp;
		for(int i =0;i<node->num_entries;i++)
		{
			obj_order[k] = node->entries[i]->son;
			//if(obj_order[k]==1)
			//	printf("***************%u\n",node->entries[i]->key[0]);
			k++;
		}
		temp =  node->get_right_sibling();
		delete node;
	}

	pb->draf = new RAF();
	pb->draf->num_obj = num_obj;
	pb->draf->init(index_name,4096,NULL);

	Object ** objS = readobjects(filename,num_obj, dim);
	int * result = pb->draf->buid_from_array(objS,obj_order);

	//delete object sets
	for(int i=0;i<num_obj;i++)
		delete objS[i];
	delete[] obj_order;

	node = pb->bplus->root_ptr;


	while(node->level!=0)
	{
		node = node->entries[0]->get_son();
	}

	k = 0;
	for(int i =0;i<node->num_entries;i++)
	{
		node->entries[i]->ptr = result[k];
		//cout<<node->entries[i]->son<<" "<<node->entries[i]->key[0]<<" "<<node->entries[i]->ptr<<endl;
	//	if(node->entries[i]->son==1)
	//		printf("%f \n",node->entries[i]->key[0]);
		k++;
	}
	char * buffer = new char[4096];
	node->write_to_buffer(buffer);

	pb->bplus->file->write_block(buffer,node->block);
	delete buffer;

	temp = node->get_right_sibling();
	//delete node;
	while(temp != NULL)
	{
		buffer = new char[4096];
		node = temp;
		for(int i =0;i<node->num_entries;i++)
		{
			node->entries[i]->ptr = result[k];
			//cout<<node->entries[i]->son<<" "<<node->entries[i]->key[0]<<" "<<node->entries[i]->ptr<<endl;
			k++;
		}
		node->write_to_buffer(buffer);		
		
		pb->bplus->file->write_block(buffer,node->block);

		delete buffer;
		temp =  node->get_right_sibling();
		delete node;
	}
	delete[] result;
	
	pb->bplus->close();
	return begin;
	//printf("%f %f %f\n",IOread,IOwrite, compdists);
}

#define ARRAYLENGTH 100



int * build_MBR(B_Node * node, PB_Tree *pb)
{
	int* minp = new int[pb->num_piv];
	int* maxp =  new int[pb->num_piv];
	for(int i =0;i<pb->num_piv;i++)
	{
		minp[i] = MAXINT;
		maxp[i] = 0;
	}
	
	if(node->level ==0)
	{
		for(int i =0;i<node->num_entries;i++)
		{
			int* t = pb->R_Zconvert(node->entries[i]->key);
			for(int j =0;j<pb->num_piv;j++)
			{
				if(t[j]<minp[j])
					minp[j] = t[j];
				if(t[j]>maxp[j])
					maxp[j] = t[j];
			}
			delete[] t;
		}
		
	}
	else
	{
		for(int i =0;i<node->num_entries;i++)
		{
			int* t = build_MBR(node->entries[i]->get_son(), pb);
			node->entries[i]->del_son();
			int * t1 = new int[pb->num_piv];
			for(int j =0;j<pb->num_piv;j++)
			{
				t1[j]= t[pb->num_piv+j];
			}
			for(int j =0;j<pb->num_piv;j++)
			{
				if(t[j]<minp[j])
					minp[j] = t[j];
				if(t1[j]>maxp[j])
					maxp[j] = t1[j];
			}
			/*for(int i =0;i<pb->num_piv;i++)
			{
				cout<<t[i]<<" "<<t1[i]<<" ";
			}
			cout<<endl;*/
			node->entries[i]->min = pb->Zconvert(t); //ڴй©
			node->entries[i]->max = pb->Zconvert(t1); //ڴй©
			
			delete[]  t;
			delete[] t1;
		}

		char * buffer = new char[4096];
		node->write_to_buffer(buffer);

		pb->bplus->file->write_block(buffer,node->block);
		delete buffer;

		/*cout<<"************"<<node->block<<"******************"<<endl;
		for(int i =0;i<pb->num_piv;i++)
		{
			cout<<minp[i]<<" "<<maxp[i]<<" ";
		}
		cout<<endl;*/
	}
//	delete node;
//	node = NULL;
	int * temp = new int[2*pb->num_piv];
	for(int i =0;i<pb->num_piv;i++)
	{
		temp[i] = minp[i];
		temp[pb->num_piv+i] = maxp[i];
	}

	delete[] minp;
	delete[] maxp;
	return temp;	
}

int * H_build_MBR(B_Node * node, PB_Tree *pb)
{
	int* minp = new int[pb->num_piv];
	int* maxp =  new int[pb->num_piv];
	for(int i =0;i<pb->num_piv;i++)
	{
		minp[i] = MAXINT;
		maxp[i] = 0;
	}
	
	if(node->level ==0)
	{
		for(int i =0;i<node->num_entries;i++)
		{
			unsigned * key = new unsigned [pb->num_piv];
			unsigned * t = new unsigned [pb->num_piv];
			for(int j =0;j<pb->bplus->keysize;j++)
			{
				t[j]=0;
				key[pb->num_piv+j-pb->bplus->keysize] = node->entries[i]->key[j];
			}
			for(int j = pb->bplus->keysize;j<pb->num_piv;j++)
			{
				t[j]=0;
				key[j-pb->bplus->keysize] = 0;
			}						
			pb->R_Hconvert(t, key, pb->num_piv);

			for(int j =0;j<pb->num_piv;j++)
			{
				if(t[j]<minp[j])
					minp[j] = t[j];
				if(t[j]>maxp[j])
					maxp[j] = t[j];
			}
			delete[] t;
			delete[] key;
		}
		
	}
	else
	{
		for(int i =0;i<node->num_entries;i++)
		{
			int* t = H_build_MBR(node->entries[i]->get_son(), pb);
			node->entries[i]->del_son();
			int * t1 = new int[pb->num_piv];
			for(int j =0;j<pb->num_piv;j++)
			{
				t1[j]= t[pb->num_piv+j];
			}
			for(int j =0;j<pb->num_piv;j++)
			{
				if(t[j]<minp[j])
					minp[j] = t[j];
				if(t1[j]>maxp[j])
					maxp[j] = t1[j];
			}
			/*for(int i =0;i<pb->num_piv;i++)
			{
				cout<<t[i]<<" "<<t1[i]<<" ";
			}
			cout<<endl;*/
			unsigned * mi = new unsigned [pb->num_piv]; 
			unsigned * ma = new unsigned [pb->num_piv]; 
			pb->Hconvert(mi,(unsigned*) t,pb->num_piv);
			pb->Hconvert(ma,(unsigned*) t1,pb->num_piv);
			node->entries[i]->min = new unsigned [pb->bplus->keysize]; 
			node->entries[i]->max = new unsigned [pb->bplus->keysize];
			for(int j =0;j<pb->bplus->keysize;j++)
			{
				node->entries[i]->min[j]=  mi[j+pb->num_piv-pb->bplus->keysize];
				node->entries[i]->max[j]=  ma[j+pb->num_piv-pb->bplus->keysize];
			}
			
			delete[] mi;
			delete[] ma;
			delete[]  t;
			delete[] t1;
		}

		char * buffer = new char[4096];
		node->write_to_buffer(buffer);

		pb->bplus->file->write_block(buffer,node->block);
		delete buffer;

	}
	/*cout<<"************"<<node->block<<"******************"<<endl;
	for(int i =0;i<pb->num_piv;i++)
	{
		cout<<minp[i]<<" "<<maxp[i]<<" ";
	}
	cout<<endl;*/
//	delete node;
//	node = NULL;
	int * temp = new int[2*pb->num_piv];
	for(int i =0;i<pb->num_piv;i++)
	{
		temp[i] = minp[i];
		temp[pb->num_piv+i] = maxp[i];
	}

	delete[] minp;
	delete[] maxp;
	return temp;	
}

void main(int argc, char* args[])
{
	basep = args[1];
	int k = atoi(args[2]);	//kʾknnеĲk ȡ2,3,5,9,17,33 
	int buffer_size = atoi(args[3]);//bufferС 
	int npiv = atoi(args[4]); //֧ 

	string sts(args[5]);
	int esti = 1;
	string ss1, ss2;
	char sk1[1000], sk2[1000];
	
	string output = basep +"\\"+ sts;
   clock_t begin,end,duration=0;
   IOread=IOwrite=0;
   ofstream ou(output,ios::app);

   sprintf(sk1, "%s\\nasa", basep);


   sprintf(sk2, "%s\\%s", basep,args[6]);

   begin = bulidIndex(sk1, sk2, npiv);
   end = clock();
   ou<<"*****************bulilding index***********num_piv="<<npiv<<"***************"<<endl;
   ou << "Build I/O= " <<IOread+IOwrite<<endl;
   ou << "Build Distcmp= " <<compdists<<endl;

	PB_Tree * pb =  new PB_Tree();
	
	Cache* c = new Cache(buffer_size,4096);
    pb->c=c;
   pb->bplus= new B_Tree();
   pb->bplus->init_restore(sk1, c);
   pb->num_piv = npiv;
   pb->readptable();
   pb->eps = EPS;
   pb->bits = BITS;
   pb->bplus->load_root();
   H_build_MBR(pb->bplus->root_ptr, pb);
   ou<<"Build Time= "<<(end-begin)/1000.0<<endl;
   
   
   pb->draf = new RAF();
   pb->draf->init_restore(sk1, c);
   
   //clock_t begin,end,duration=0;
   Object * q = new Object();   
   char sk3[1000];
   sprintf(sk3, "%s\\%s", basep,args[7]);
   ifstream in(sk3);
   //ofstream ou(output,ios::app);
   ou<<"************cachesize="<<buffer_size<<"*****k="<<k<<"******"<<endl;
   double io=0;
   double dists=0;
   int n = 500;
   q->size = 16;
   q->data= new float[q->size];
   begin=clock();
   double radius =0;
   double pf =0;
   for(int j =0;j<n;j++)
   {  
	   IOread = 0;
	   c->clear();
	   compdists=0;	 
	  
	   for(int i=0;i<q->size;i++)
	   {		   
		   in>>q->data[i];
		   q->data[i] = q->data[i]*1000;
	   }


	   radius +=pb->BFkNN(q,k);
	   //if (args[8][0] == 'I' || args[8][0] == 'i')radius += pb->ImprovedkNN(q, k, esti);
	   io+=IOread;
	   pf += c->page_faults;
		//io+=IOread;
	   dists+=compdists;
   }
   end = clock();
   ou<<"Time= "<<(end-begin)/(n*1000.0)<<endl;
   ou<<"I/O= "<<io/n<<endl;
   ou << "Distcmp= " <<dists/n<<endl;
   
}


