#include "pb-tree.h"
#include ".\gadget\gadget.h"
#include <math.h>
#include <vector>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <sstream>
#include <bitset>
#include <queue>
using namespace std;
extern double cc;
extern double IOread;
extern char  sss1[1000], sss2[1000];
extern string basep;
PB_Tree::PB_Tree()
{
	bplus = NULL;
	draf = NULL;
	ptable = NULL;
	cand = NULL;
	c = NULL;
	num_piv = -1;
	eps = -1;
}

PB_Tree::~PB_Tree()
{
	if(bplus!=NULL)
		delete bplus;
	if(draf!=NULL)
		delete draf;
	if(ptable!=NULL)
		delete[] ptable;
}


//find num_cand pivots in O using FFT
double** PB_Tree::FFT(Object * O, int num)
{
	cand = new Object[num_cand];
	bool * indicator = new bool[num];
	for (int i = 0; i < num; i++)
		indicator[i] = true;
	int * idset = new int[num_cand];

	double d = 0.0;
	double t;
	int choose = 0;
	//洢жpivot
	double** distmatrix = new double*[num];
	for (int i = 0; i < num; i++)
	{
		distmatrix[i] = new double[num_cand];
		for (int j = 0; j < num_cand; j++)
			distmatrix[i][j] = 0;
	}

	//ѡȡһpivot
	if (num_cand > 0)
	{

		for (int i = 1; i < num; i++)
		{
			t = O[i].distance(O[0]);
			if (t > d)
			{
				d = t;
				choose = i;
			}
		}

		idset[0] = choose;
		cand[0] = O[choose];
		indicator[choose] = false;
		//distmatrix[choose][0]=0;
	}

	//ѡȡڶpivot
	if (num_cand > 1)
	{
		d = 0;
		for (int i = 0; i < num; i++)
		{
			if (indicator[i])
			{
				distmatrix[i][0] = cand[0].distance(O[i]);
				if (distmatrix[i][0] > d)
				{
					d = distmatrix[i][0];
					choose = i;
				}
			}
		}

		idset[1] = choose;
		cand[1] = O[choose];
		indicator[choose] = false;
		//distmatrix[choose][1]=0;
	}

	//ѡȡʣpivots
	d = 0;
	for (int i = 2; i < num_cand; i++)
	{
		d = 0;
		for (int j = 0; j < num; j++)
		{
			if (indicator[j])
			{
				t = MAXREAL;
				for (int k = 0; k < i - 1; k++)
				{
					if (distmatrix[j][k] < t)
						t = distmatrix[j][k];
				}
				distmatrix[j][i - 1] = O[j].distance(cand[i - 1]);
				if (distmatrix[j][i - 1] < t)
					t = distmatrix[j][i - 1];
				if (t > d)
				{
					d = t;
					choose = j;
				}
			}
		}

		idset[i] = choose;
		//distmatrix[choose][i]= 0;
		indicator[choose] = false;
		cand[i] = O[choose];
	}


	//print distance matrix

	for (int i = 0; i < num; i++)
	{
		if (indicator[i])
		{
			distmatrix[i][num_cand - 1] = O[i].distance(cand[num_cand - 1]);
		}
	}

	for (int i = 0; i < num_cand; i++)
		for (int j = i + 1; j < num_cand; j++)
			distmatrix[idset[i]][j] = O[idset[i]].distance(cand[j]);

	delete[] indicator;
	delete[] idset;

	return distmatrix;
}


//find num_cand pivots in O using maxpruning strategy
double** PB_Tree::MaxPrunning(Object * O, int num)
{
	cand = new Object[num_cand];
	bool * indicator = new bool[num];
	for (int i = 0; i < num; i++)
		indicator[i] = true;
	int * idset = new int[num_cand];

	double d = 0.0;
	double t;
	int choose = 0;
	//洢жpivot
	double** distmatrix = new double*[num];
	for (int i = 0; i < num; i++)
	{
		distmatrix[i] = new double[num_cand];
		for (int j = 0; j < num_cand; j++)
			distmatrix[i][j] = 0;
	}

	//ѡȡһpivot
	if (num_cand > 0)
	{

		for (int i = 1; i < num; i++)
		{
			t = O[i].distance(O[0]);
			if (t > d)
			{
				d = t;
				choose = i;
			}
		}

		idset[0] = choose;
		cand[0] = O[choose];
		indicator[choose] = false;
		//distmatrix[choose][0]=0;
	}

	//ѡȡڶpivot
	if (num_cand > 1)
	{
		d = 0;
		for (int i = 0; i < num; i++)
		{
			if (indicator[i])
			{
				distmatrix[i][0] = cand[0].distance(O[i]);
				if (distmatrix[i][0] > d)
				{
					d = distmatrix[i][0];
					choose = i;
				}
			}
		}

		idset[1] = choose;
		cand[1] = O[choose];
		indicator[choose] = false;
		//distmatrix[choose][1]=0;
	}

	//ѡȡʣpivots
	double edge = d;
	d = MAXREAL;
	for (int i = 2; i < num_cand; i++)
	{
		d = MAXREAL;
		for (int j = 0; j < num; j++)
		{
			if (indicator[j])
			{
				t = 0;
				for (int k = 0; k < i - 1; k++)
				{
					t += fabs(edge - distmatrix[j][k]);
				}
				distmatrix[j][i - 1] = O[j].distance(cand[i - 1]);
				t += fabs(edge - distmatrix[j][i - 1]);
				if (t < d)
				{
					d = t;
					choose = j;
				}
			}
		}

		idset[i] = choose;
		//distmatrix[choose][i]= 0;
		indicator[choose] = false;
		cand[i] = O[choose];
	}


	//print distance matrix

	for (int i = 0; i < num; i++)
	{
		if (indicator[i])
		{
			distmatrix[i][num_cand - 1] = O[i].distance(cand[num_cand - 1]);
		}
	}

	for (int i = 0; i < num_cand; i++)
		for (int j = i + 1; j < num_cand; j++)
			distmatrix[idset[i]][j] = O[idset[i]].distance(cand[j]);

	delete[] indicator;
	delete[] idset;

	return distmatrix;
}

void PB_Tree::PivotSelect(Object * O, Object * Q, int o_num, int q_num, double thred)
{
	vector<int> pivots;

	double ** O_P_matrix = MaxPrunning(O, o_num);

	double ** Q_O_matrix = new double *[q_num];
	double ** Q_P_matrix = new double*[q_num];
	double ** esti = new double*[q_num];
	for (int i = 0; i < q_num; i++)
	{
		Q_O_matrix[i] = new double[o_num];
		Q_P_matrix[i] = new double[num_cand];
		esti[i] = new double[o_num];
	}
	bool* indicator = new bool[num_cand];
	for (int i = 0; i < num_cand; i++)
		indicator[i] = true;


	for (int i = 0; i < q_num; i++)
	{
		for (int j = 0; j < o_num; j++)
		{
			Q_O_matrix[i][j] = Q[i].distance(O[j]);
			esti[i][j] = 0;
		}
		for (int j = 0; j < num_cand; j++)
		{
			Q_P_matrix[i][j] = Q[i].distance(cand[j]);
		}
	}

	double d = 0;
	double t = 0;
	double last = 0;
	int choose;
	ptable = new Object[num_piv];
	int i;
	while (true)
	{
		choose = -1;
		for (int j = 0; j < num_cand; j++)
		{
			if (indicator[j])
			{
				t = 0;
				for (int m = 0; m < q_num; m++)
				{
					for (int n = 0; n < o_num; n++)
					{
						if (Q_O_matrix[m][n] != 0)
						{
							//if(fabs(Q_P_matrix[m][j]-O_P_matrix[n][j])>Q_O_matrix[m][n])
							//	cout<<m<<" "<<n<<" "<<j<<" "<<fabs(Q_P_matrix[m][j]-O_P_matrix[n][j])<<"*****"<<Q_O_matrix[m][n]<<endl;
							t += (MAX(fabs(Q_P_matrix[m][j] - O_P_matrix[n][j]), esti[m][n])) / Q_O_matrix[m][n];
						}
					}
				}
				t = t / (q_num*o_num);
				if (t > d)
				{
					choose = j;
					d = t;
				}
			}
		}

		printf("%d %f\n", choose, d);
		if (choose == -1 || d - last < thred)
			break;
		last = d;
		indicator[choose] = false;
		pivots.push_back(choose);
		for (int m = 0; m < q_num; m++)
			for (int n = 0; n < o_num; n++)
				esti[m][n] = MAX(fabs(Q_P_matrix[m][choose] - O_P_matrix[n][choose]), esti[m][n]);
	}


	int victim;
	int iter = 0;
	while (true)
	{
		d = 1;
		iter++;
		//ѡȡcontributionСpivot
		victim = -1;
		for (int i = 0; i < pivots.size(); i++)
		{
			for (int m = 0; m < q_num; m++)
				for (int n = 0; n < o_num; n++)
					esti[m][n] = 0;

			for (int j = 0; j < pivots.size(); j++)
			{
				if (j != i)
				{
					for (int m = 0; m < q_num; m++)
						for (int n = 0; n < o_num; n++)
							esti[m][n] = MAX(fabs(Q_P_matrix[m][pivots[j]] - O_P_matrix[n][pivots[j]]), esti[m][n]);
				}
			}

			t = 0;
			for (int m = 0; m < q_num; m++)
			{
				for (int n = 0; n < o_num; n++)
				{
					if (Q_O_matrix[m][n] != 0)
						t += esti[m][n] / Q_O_matrix[m][n];
				}
			}

			t = t / (q_num*o_num);
			printf("contribution %d %f\n", i, last - t);
			if (last - t < d)
			{
				victim = i;
				d = last - t;
			}
		}

		for (int m = 0; m < q_num; m++)
			for (int n = 0; n < o_num; n++)
				esti[m][n] = 0;

		for (int j = 0; j < pivots.size(); j++)
		{
			if (j != victim)
			{
				for (int m = 0; m < q_num; m++)
					for (int n = 0; n < o_num; n++)
						esti[m][n] = MAX(fabs(Q_P_matrix[m][pivots[j]] - O_P_matrix[n][pivots[j]]), esti[m][n]);
			}
		}

		printf("victim %d %f\n", victim, d);

		//ѡȡһ滻victim
		choose = -1;
		d = last;
		for (int j = 0; j < num_cand; j++)
		{
			if (indicator[j])
			{
				t = 0;
				for (int m = 0; m < q_num; m++)
				{
					for (int n = 0; n < o_num; n++)
					{
						if (Q_O_matrix[m][n] != 0)
						{
							t += (MAX(fabs(Q_P_matrix[m][j] - O_P_matrix[n][j]), esti[m][n])) / Q_O_matrix[m][n];
						}
					}
				}
				t = t / (q_num*o_num);
				if (t > d)
				{
					choose = j;
					d = t;
				}
			}
		}

		printf("%d %f\n", choose, d);
		//	if(choose == -1||iter>20)
		if (choose == -1 || d - last < thred)
			break;
		last = d;
		indicator[choose] = false;
		indicator[pivots[victim]] = true;
		pivots.erase(pivots.begin() + victim);
		pivots.push_back(choose);
	}

	num_piv = pivots.size();
	ptable = new Object[num_piv];
	for (int i = 0; i < num_piv; i++)
		ptable[i] = cand[pivots[i]];

	for (i = 0; i < q_num; i++)
	{
		delete[] esti[i];
		delete[] Q_P_matrix[i];
		delete[] Q_O_matrix[i];
	}
	delete[] indicator;
	for (i = 0; i < o_num; i++)
		delete[] O_P_matrix[i];
}

void PB_Tree::PivotSelect(Object * O, Object * Q, int o_num, int q_num)
{
	double ** O_P_matrix = MaxPrunning(O, o_num);

	double ** Q_O_matrix = new double *[q_num];
	double ** Q_P_matrix = new double*[q_num];
	double ** esti = new double*[q_num];
	for (int i = 0; i < q_num; i++)
	{
		Q_O_matrix[i] = new double[o_num];
		Q_P_matrix[i] = new double[num_cand];
		esti[i] = new double[o_num];
	}
	bool* indicator = new bool[num_cand];
	for (int i = 0; i < num_cand; i++)
		indicator[i] = true;


	for (int i = 0; i < q_num; i++)
	{
		for (int j = 0; j < o_num; j++)
		{
			Q_O_matrix[i][j] = Q[i].distance(O[j]);
			esti[i][j] = 0;
		}
		for (int j = 0; j < num_cand; j++)
		{
			Q_P_matrix[i][j] = Q[i].distance(cand[j]);
		}
	}


	double d = 0;
	double t = 0;
	int choose;
	ptable = new Object[num_piv];
	int i;
	for (i = 0; i < num_piv; i++)
	{
		choose = -1;
		for (int j = 0; j < num_cand; j++)
		{
			if (indicator[j])
			{
				t = 0;
				for (int m = 0; m < q_num; m++)
				{
					for (int n = 0; n < o_num; n++)
					{
						if (Q_O_matrix[m][n] != 0)
						{
							//if(fabs(Q_P_matrix[m][j]-O_P_matrix[n][j])>Q_O_matrix[m][n])
							//	cout<<m<<" "<<n<<" "<<j<<" "<<fabs(Q_P_matrix[m][j]-O_P_matrix[n][j])<<"*****"<<Q_O_matrix[m][n]<<endl;
							t += (MAX(fabs(Q_P_matrix[m][j] - O_P_matrix[n][j]), esti[m][n])) / Q_O_matrix[m][n];
						}
					}
				}
				t = t / (q_num*o_num);
				if (t > d)
				{
					choose = j;
					d = t;
				}
			}
		}
		printf("%d %f\n", choose, d);
		if (choose == -1)
			break;
		indicator[choose] = false;
		ptable[i] = cand[choose];
		for (int m = 0; m < q_num; m++)
			for (int n = 0; n < o_num; n++)
				esti[m][n] = MAX(fabs(Q_P_matrix[m][choose] - O_P_matrix[n][choose]), esti[m][n]);
	}

	if (i < num_piv)
	{
		num_piv = i;
	}

	for (i = 0; i < q_num; i++)
	{
		delete[] esti[i];
		delete[] Q_P_matrix[i];
		delete[] Q_O_matrix[i];
	}
	delete[] indicator;
	for (i = 0; i < o_num; i++)
		delete[] O_P_matrix[i];

	// delete cand;
}

void PB_Tree::RPivotSelect(Object * O, Object * Q, int o_num, int q_num)
{
	ptable = new Object[num_piv];
	double ** O_P_matrix = MaxPrunning(O, o_num);
	double ** Q_O_matrix = new double *[q_num];
	double ** Q_P_matrix = new double*[q_num];

	double ** esti = new double*[q_num];
	for (int i = 0; i < q_num; i++)
	{
		Q_O_matrix[i] = new double[o_num];
		Q_P_matrix[i] = new double[num_cand];
		esti[i] = new double[o_num];
	}

	double *** esti_temp = new double **[num_cand];
	for (int i = 0; i < num_cand; i++)
	{
		esti_temp[i] = new double*[q_num];
		for (int j = 0; j < q_num; j++)
			esti_temp[i][j] = new double[o_num];
	}

	for (int i = 0; i < q_num; i++)
	{
		for (int j = 0; j < o_num; j++)
		{
			Q_O_matrix[i][j] = Q[i].distance(O[j]);
			esti[i][j] = 0;
		}
		for (int j = 0; j < num_cand; j++)
		{
			Q_P_matrix[i][j] = Q[i].distance(cand[j]);
		}
	}

	double score = 0;

	for (int i = 0; i < q_num; i++)
	{
		for (int j = 0; j < o_num; j++)
		{
			for (int k = 0; k < num_cand; k++)
			{
				esti_temp[k][i][j] = fabs(Q_P_matrix[i][k] - O_P_matrix[j][k]);
				if (esti[i][j] < esti_temp[k][i][j])
					esti[i][j] = esti_temp[k][i][j];
			}
			if (Q_O_matrix[i][j] != 0)
				score += esti[i][j] / Q_O_matrix[i][j];
		}
	}
	score = score / (q_num*o_num);
	cout << "score: " << score << endl;

	bool * flag_c = new bool[num_cand];

	for (int i = 0; i < num_cand; i++)
	{
		flag_c[i] = true;
	}

	double * contribution = new double[num_cand];
	double temp = MAXREAL;
	int choose;
	double t;
	for (int i = 0; i < num_cand - num_piv; i++)  //һҪ num_cand-num_piv
	{
		temp = MAXREAL;
		for (int j = 0; j < num_cand; j++)
		{
			if (flag_c[j])
			{
				contribution[j] = 0;
				for (int m = 0; m < q_num; m++)
				{
					for (int n = 0; n < o_num; n++)
					{
						if (esti[m][n] == esti_temp[j][m][n])
						{
							t = 0;
							for (int k = 0; k < num_cand; k++)
							{
								if (flag_c[k] && k != j && esti_temp[k][m][n] > t)
									t = esti_temp[k][m][n];

							}
							if (Q_O_matrix[m][n] != 0)
								contribution[j] += (esti[m][n] - t) / Q_O_matrix[m][n];
						}
					}
				}
				if (contribution[j] < temp)
				{
					temp = contribution[j];
					choose = j;
				}
			}
		}
		flag_c[choose] = false;
		cout << choose << " " << contribution[choose] << endl;
		for (int m = 0; m < q_num; m++)
		{
			for (int n = 0; n < o_num; n++)
			{
				if (esti[m][n] == esti_temp[choose][m][n])
				{
					t = 0;
					for (int k = 0; k < num_cand; k++)
					{
						if (flag_c[k])
							if (esti_temp[k][m][n] > t)
								t = esti_temp[k][m][n];
					}
					esti[m][n] = t;
				}
			}
		}
	}
	score = 0;
	for (int i = 0; i < q_num; i++)
		for (int j = 0; j < o_num; j++)
		{
			if (Q_O_matrix[i][j] != 0)
				score += esti[i][j] / Q_O_matrix[i][j];
		}
	cout << score / (q_num*o_num) << endl;

	choose = 0;
	for (int i = 0; i < num_cand; i++)
		if (flag_c[i])
		{
			ptable[choose] = cand[i];
			choose++;
		}

	delete[] flag_c;
	delete[] contribution;

	for (int i = 0; i < q_num; i++)
	{
		delete[] esti[i];
		delete[] Q_P_matrix[i];
		delete[] Q_O_matrix[i];
	}
	for (int i = 0; i < o_num; i++)
		delete[] O_P_matrix[i];
	for (int i = 0; i < num_cand; i++)
	{
		for (int j = 0; j < q_num; j++)
			delete[] esti_temp[i][j];
		delete[] esti_temp[i];
	}
	delete[] esti_temp;

}

//******need to set bits and eps values******
//bits: the number bits to represent the distance
//eps: to partion the domain of the distance
unsigned * PB_Tree:: Zconvert(int * dist)
{
	int keysize = (num_piv * bits)/32;
	if((num_piv * bits)%32!=0)
		keysize = keysize +1;
	unsigned * zvalue = new unsigned[keysize];
	int temp = 32*keysize;
	int* zbits = new int[temp];
    memset(zbits, 0, sizeof(int) * temp);
	for(int i = 0;i<num_piv;i++)
	{
		bitset<32> bs(dist[i]);
		for(int j = 1;j<=bits;j++)
			zbits[j*num_piv-i-1]=bs.test(j-1);
	}
	for(int i =0;i<keysize;i++)
	{
		temp-=32;
		bitset<32> key;
		for(int j =0;j<32;j++)
			if(zbits[temp+j])
				key.set(j); 
		zvalue[i]= key.to_ulong();
	}
	delete[] zbits;
	return zvalue;
}

void PB_Tree::Zconvert(Object *o)
{
	int keysize = (num_piv * bits)/32;
	if((num_piv * bits)%32!=0)
		keysize = keysize +1;
	o->keysize = keysize;
	o->key = new unsigned [keysize];

	int * dists = new int[num_piv]; 
	int temp = 32*keysize;
	int* zbits = new int[temp];
	memset(zbits, 0, sizeof(int) * temp);
	for(int i =0;i<num_piv;i++)
	{
		if(eps >0)
			dists[i] = (int) floor(o->distance(ptable[i])/eps);
		else
			dists[i]= (int) o->distance(ptable[i]);
		bitset<32> bs(dists[i]);
		for(int j = 1;j<=bits;j++)
		{
			zbits[j*num_piv-i-1]=bs.test(j-1);
		}
	}
	for(int i =temp-1;i>=0;i--)
	{
		if(zbits[i]==0)
		{
			o->keycomp.append("0");
		}
		else
		{
			o->keycomp.append("1");
		}
	}

	for(int i =0;i<keysize;i++)
	{
		temp -=32;
		bitset<32> key;
		for(int j =0;j<32;j++)
		{
			if(zbits[temp+j])
				key.set(j); 
		}		
		o->key[i] = key.to_ulong();
	}
	delete[] dists;
	delete[] zbits;
}

int* PB_Tree::R_Zconvert(unsigned * okey)
{
	int keysize = (num_piv * bits)/32;
	if((num_piv * bits)%32!=0)
		keysize = keysize +1;
	unsigned * key = new unsigned [keysize];
	memcpy(key, okey, keysize*sizeof(unsigned));
	int temp = 32*keysize;
	int * zbits = new int[temp];
	memset(zbits, 0, sizeof(int) * temp);
	for(int i =0;i<keysize;i++)
	{	
		int tt = (keysize-1-i)*32;
		for(int j = 0;j<32 && key[i]!=0;key[i]>>=1,j++)
		{
			if(key[i]&1)
				zbits[tt+j]=1;
		}
	}

	int* d = new int[num_piv];
	for(int i=0;i<num_piv;i++)
		d[i]=0;

	for(int j =0;j<num_piv;j++)
	{
		bitset<32> data;
		for(int i=0;i<bits;i++)
		{
			if(zbits[i*num_piv+num_piv-1-j])
				data.set(i);
		}
		d[j]=data.to_ulong();
	}
	delete[] zbits;

	delete[] key;
	okey = NULL;
	return d;
}

void PB_Tree::Hconvert(Object *o)
{
	int keysize = (num_piv * bits)/32;
	if((num_piv * bits)%32!=0)
		keysize = keysize +1;
	o->keysize = keysize;
	o->key = new unsigned [keysize];

	unsigned  * dists = new unsigned[num_piv]; 
	unsigned * key = new unsigned[num_piv];
	for(int i =0;i<num_piv;i++)
	{
		key[i] =0;
		if(eps >0)
			dists[i] = (int) floor(o->distance(ptable[i])/eps);
		else
			dists[i]= (int) o->distance(ptable[i]);
	}

	Hconvert(key, dists, num_piv);

	for(int i =0;i<keysize;i++)
	{
		o->key[i]=key[num_piv-keysize+i];
	}
	
	delete[] dists;
	delete[] key;
}

unsigned * PB_Tree:: Hconvert ( unsigned* hcode,  unsigned* point, int DIMS ) {
    unsigned mask = ( unsigned ) 1 << WORDBITS - 1, element, temp1, temp2,
             A, W = 0, S, tS, T, tT, J, P = 0, xJ;
    int	i = NUMBITS * DIMS - DIMS, j;
//     i=k*32;
    // initialise hcode
    memset ( hcode, 0, sizeof ( unsigned ) * DIMS );

    for ( j = A = 0; j < DIMS; j++ )
        if ( point[j] & mask )
            A |= ( 1 << ( DIMS-1-j ) );

    S = tS = A;

    P |= S & ( 1 << ( DIMS-1 ) );
    for ( j = 1; j < DIMS; j++ )
        if ( S & 1 << ( DIMS-1-j ) ^ ( P >> 1 ) & ( 1 << ( DIMS-1-j ) ) )
            P |= ( 1 << ( DIMS-1-j ) );

    /* add in DIMS bits to hcode */
    element = i / WORDBITS;
    if ( i % WORDBITS > WORDBITS - DIMS ) {
        hcode[element] |= P << i % WORDBITS;
        hcode[element + 1] |= P >> WORDBITS - i % WORDBITS;
    } else
        hcode[element] |= P << i - element * WORDBITS;

    J = DIMS;
    for ( j = 1; j < DIMS; j++ )
        if ( ( P >> j & 1 ) == ( P & 1 ) )
            continue;
        else
            break;
    if ( j != DIMS )
        J -= j;
    xJ = J - 1;

    if ( P < 3 )
        T = 0;
    else if ( P % 2 )
        T = ( P - 1 ) ^ ( P - 1 ) / 2;
    else
        T = ( P - 2 ) ^ ( P - 2 ) / 2;
    tT = T;

    /*
    printf ("           A   W  tS   S   P   J  xJ   T  tT\n\n");
    printf ("        %4u%4u%4u%4u%4u%4u%4u%4u%4u\n\n", A, W, tS, S, P, J, xJ, T, tT);
    */

    for ( i -= DIMS, mask >>= 1; i >=0; i -= DIMS, mask >>= 1 ) {
        for ( j = A = 0; j < DIMS; j++ )
            if ( point[j] & mask )
                A |= ( 1 << ( DIMS-1-j ) );

        W ^= tT;
        tS = A ^ W;
        if ( xJ % DIMS != 0 ) {
            temp1 = tS << xJ % DIMS;
            temp2 = tS >> DIMS - xJ % DIMS;
            S = temp1 | temp2;
            S &= ( ( unsigned ) 1 << DIMS ) - 1;
        } else
            S = tS;

        P = S & ( 1 << ( DIMS-1 ) );
        for ( j = 1; j < DIMS; j++ )
            if ( S & ( 1 << ( DIMS-1-j ) ) ^ ( P >> 1 ) & ( 1 << ( DIMS-1-j ) ) )
                P |= ( 1 << ( DIMS-1-j ) );

        /* add in DIMS bits to hcode */
        element = i / WORDBITS;
        if ( i % WORDBITS > WORDBITS - DIMS ) {
            hcode[element] |= P << i % WORDBITS;
            hcode[element + 1] |= P >> WORDBITS - i % WORDBITS;
        } else
            hcode[element] |= P << i - element * WORDBITS;

        if ( i > 0 ) {
            if ( P < 3 )
                T = 0;
            else if ( P % 2 )
                T = ( P - 1 ) ^ ( P - 1 ) / 2;
            else
                T = ( P - 2 ) ^ ( P - 2 ) / 2;

            if ( xJ % DIMS != 0 ) {
                temp1 = T >> xJ % DIMS;
                temp2 = T << DIMS - xJ % DIMS;
                tT = temp1 | temp2;
                tT &= ( ( unsigned ) 1 << DIMS ) - 1;
            } else
                tT = T;

            J = DIMS;
            for ( j = 1; j < DIMS; j++ )
                if ( ( P >> j & 1 ) == ( P & 1 ) )
                    continue;
                else
                    break;
            if ( j != DIMS )
                J -= j;

            xJ += J - 1;
            /*	J %= DIMS;*/
        }

// printf ("        %4u%4u%4u%4u%4u%4u%4u%4u%4u\n\n", A, W, tS, S, P, J, xJ, T, tT);

    }

	// add by Lu Chen
	unsigned * temp = new unsigned [DIMS];

	for(int i =0;i<DIMS;i++)
	{
		temp[i]=hcode[i];
	}

	for(int i =0;i<DIMS;i++)
	{
		hcode[i]=temp[DIMS-i-1];
	}

	delete[] temp;
    return hcode;
}

unsigned * PB_Tree:: R_Hconvert ( unsigned* point, unsigned* hc, int DIMS )
{
	// add by Lu Chen
	unsigned * hcode = new unsigned [DIMS];
	for(int i =0;i<DIMS;i++)
		hcode [i] = hc[DIMS-i-1];

	unsigned   mask = (unsigned)1 << WORDBITS - 1, element, temp1, temp2,
                A, W = 0, S, tS, T, tT, J, P = 0, xJ;
        int     i = NUMBITS * DIMS - DIMS, j;


        /*--- P ---*/
        element = i / WORDBITS;
        P = hcode[element];
        if (i % WORDBITS > WORDBITS - DIMS)
        {
                temp1 = hcode[element + 1];
                P >>= i % WORDBITS;
                temp1 <<= WORDBITS - i % WORDBITS;
                P |= temp1;
        }
        else
                P >>= i % WORDBITS;     /* P is a DIMS bit hcode */

        /* the & masks out spurious highbit values */
        #if DIMS < WORDBITS
                P &= (1 << DIMS) -1;
        #endif

        /*--- xJ ---*/
        J = DIMS;
        for (j = 1; j < DIMS; j++)
                if ((P >> j & 1) == (P & 1))
                        continue;
                else
                        break;
        if (j != DIMS)
                J -= j;
        xJ = J - 1;

        /*--- S, tS, A ---*/
        A = S = tS = P ^ P / 2;


        /*--- T ---*/
        if (P < 3)
                T = 0;
        else
                if (P % 2)
                        T = (P - 1) ^ (P - 1) / 2;
                else
                        T = (P - 2) ^ (P - 2) / 2;

        /*--- tT ---*/
        tT = T;

        /*--- distrib bits to coords ---*/
        for (j = DIMS - 1; P > 0; P >>=1, j--)
                if (P & 1)
                        point[j] |= mask;


        for (i -= DIMS, mask >>= 1; i >=0; i -= DIMS, mask >>= 1)
        {
                /*--- P ---*/
                element = i / WORDBITS;
                P = hcode[element];
                if (i % WORDBITS > WORDBITS - DIMS)
                {
                        temp1 = hcode[element + 1];
                        P >>= i % WORDBITS;
                        temp1 <<= WORDBITS - i % WORDBITS;
                        P |= temp1;
                }
                else
                        P >>= i % WORDBITS;     /* P is a DIMS bit hcode */

                /* the & masks out spurious highbit values */
                #if DIMS < WORDBITS
                        P &= (1 << DIMS) -1;
                #endif

                /*--- S ---*/
                S = P ^ P / 2;

                /*--- tS ---*/
                if (xJ % DIMS != 0)
                {
                        temp1 = S >> xJ % DIMS;
                        temp2 = S << DIMS - xJ % DIMS;
                        tS = temp1 | temp2;
                        tS &= ((unsigned)1 << DIMS) - 1;
                }
                else
                        tS = S;

                /*--- W ---*/
                W ^= tT;

                /*--- A ---*/
                A = W ^ tS;

                /*--- distrib bits to coords ---*/
                for (j = DIMS - 1; A > 0; A >>=1, j--)
                        if (A & 1)
                                point[j] |= mask;

                if (i > 0)
                {
                        /*--- T ---*/
                        if (P < 3)
                                T = 0;
                        else
                                if (P % 2)
                                        T = (P - 1) ^ (P - 1) / 2;
                                else
                                        T = (P - 2) ^ (P - 2) / 2;

                        /*--- tT ---*/
                        if (xJ % DIMS != 0)
                        {
                                temp1 = T >> xJ % DIMS;
                                temp2 = T << DIMS - xJ % DIMS;
                                tT = temp1 | temp2;
                                tT &= ((unsigned)1 << DIMS) - 1;
                        }
                        else
                                tT = T;

                        /*--- xJ ---*/
                        J = DIMS;
                        for (j = 1; j < DIMS; j++)
                                if ((P >> j & 1) == (P & 1))
                                        continue;
                                else
                                        break;
                        if (j != DIMS)
                                J -= j;
                        xJ += J - 1;
                }
        }
		delete[] hcode;
        return point;
}

void PB_Tree::readptable()
{
	char  sr1[1000];
	sprintf(sr1, "%s\\ptable.txt", basep);
	ifstream in1(sr1);
	in1>>num_piv;
	ptable = new Object[num_piv];
	for(int i =0;i<num_piv;i++)
	{
		in1>>ptable[i].id>>ptable[i].size;
		cout << ptable[i].id << endl;
		ptable[i].data = new float[ptable[i].size];
		for(int j =0;j<ptable[i].size;j++)
		{
			in1>>ptable[i].data[j];
			//ptable[i].data[j] = ptable[i].data[j]*1000;
		}
	}
	in1.close();
}

void PB_Tree::H_bulkload(Object * O, int o_num)
{
	vector<HEntry> H;
	for(int i =0;i<o_num;i++)
	{
		Hconvert(&O[i]);
		HEntry h(O[i].key, O[i].keysize, O[i].id);
		H.push_back(h);
	}
	sort(H.begin(), H.end());
	char  sr1[1000];
	sprintf(sr1, "%s\\bulkload.txt", basep);
	FILE* f = fopen(sr1, "w+");

	if(f!=NULL)
	{
		/*for(int i=0;i<o_num;i++)
		{
			fprintf(f, "%d ", O[i].id);
			for(int j =0;j<O[i].keysize;j++)
				fprintf(f, "%u ", O[i].key[j]);
			fprintf(f,"\n");
		}*/

		for(int i=0;i<o_num;i++)
		{
			fprintf(f, "%d ", H[i].id);
			for(int j =0;j<H[i].keysize;j++)
				fprintf(f, "%u ", H[i].key[j]);
			fprintf(f,"\n");
		}
		fclose(f);
	}
	H.clear();
}

void PB_Tree::bulkload(Object * O, int o_num)
{	
	vector<TEntry> v;
	for(int i =0;i<o_num;i++)
	{
		Zconvert(&O[i]);
		//Hconvert(&O[i]);
		TEntry e;
		e.id = i;
		e.key = O[i].keycomp;
		v.push_back(e);
	}
	sort(v.begin(),v.end());

	char  sr1[1000];
	sprintf(sr1, "%s\\bulkload.txt", basep);
	FILE* f = fopen(sr1, "w+");

	if(f!=NULL)
	{
		for(int i=0;i<o_num;i++)
		{
			fprintf(f, "%d ", O[v[i].id].id);
			for(int j =0;j<O[v[i].id].keysize;j++)
				fprintf(f, "%u ", O[v[i].id].key[j]);
			fprintf(f,"\n");
		}
		fclose(f);
	}
	v.clear();
}

void clear(vector<B_Node *> * inodes)
{
	for(int i =0;i<inodes->size();i++)
	{
		if((*inodes)[i]->num_entries ==0)
		{
			inodes->erase(inodes->begin()+i);
			i--;
		}
	}
};
int PB_Tree::idist(int * q, int* mi, int* ma)
{
	int dist =0;
	int temp;
	for(int i =0;i<num_piv;i++)
	{
		if(q[i]<mi[i])
			temp = mi[i]-q[i];
		else if(q[i]>ma[i])
			temp = q[i]-ma[i];
		else
			temp =0;
		if(dist<temp)
			dist = temp;
	}
	return dist;
}

double PB_Tree::BFkNN(Object*q, int k)
{
	int * dists = new int[num_piv];
	for (int i = 0; i < num_piv; i++)
	{
		if (eps > 0)
			dists[i] = (int)floor(q->distance(ptable[i]) / eps);
		else
			dists[i] = (int)q->distance(ptable[i]);
	}
	int addition = 0;
	int temp;
	if (eps > 0)
		temp = eps;
	else
		temp = 1;
	if (eps > 0)
		addition = eps;

	vector<SortEntry> kNN;
	double kdist = MAXREAL;
	priority_queue<kNNEntry> queue;
	bplus->load_root();
	B_Node* node = bplus->root_ptr;
	for (int i = 0; i < node->num_entries; i++)
	{
		unsigned * key1 = new unsigned[num_piv];
		unsigned * mm1 = new unsigned[num_piv];
		for (int j = 0; j < bplus->keysize; j++)
		{
			mm1[j] = 0;
			key1[num_piv + j - bplus->keysize] = node->entries[i]->min[j];
		}
		for (int j = bplus->keysize; j < num_piv; j++)
		{
			mm1[j] = 0;
			key1[j - bplus->keysize] = 0;
		}
		R_Hconvert(mm1, key1, num_piv);

		unsigned * key2 = new unsigned[num_piv];
		unsigned * mm2 = new unsigned[num_piv];
		for (int j = 0; j < bplus->keysize; j++)
		{
			mm2[j] = 0;
			key2[num_piv + j - bplus->keysize] = node->entries[i]->max[j];
		}
		for (int j = bplus->keysize; j < num_piv; j++)
		{
			mm2[j] = 0;
			key2[j - bplus->keysize] = 0;
		}
		R_Hconvert(mm2, key2, num_piv);
		delete[] key1;
		delete[] key2;
		int * m1 = new int[num_piv];
		int * m2 = new int[num_piv];
		for (int j = 0; j < num_piv; j++)
		{
			m1[j] = mm1[j];
			m2[j] = mm2[j];
		}
		delete[] mm1;
		delete[] mm2;
		kNNEntry e;
		e.edist = idist(dists, m1, m2);

		delete[] m1;
		delete[] m2;
		if (node->level > 0)
			e.ptr = node->entries[i]->son;
		else
			e.ptr = node->entries[i]->ptr;
		e.level = node->entries[i]->level;
		queue.push(e);
	}
	delete node;
	node = NULL;
	while (!queue.empty())
	{
		kNNEntry e = queue.top();
		//cout<<queue.size()<<" "<<e.level<<" "<<e.edist<<" "<<e.ptr<<endl;
		queue.pop();
		if (e.edist*temp >= kdist + addition)
		{
			break;
		}
		if (e.level > 0) // pop an intermediate entry and push its qualified sub entries
		{
			node = bplus->read_node(e.ptr);
			if (e.level > 1)
			{
				for (int i = 0; i < node->num_entries; i++)
				{
					unsigned * key1 = new unsigned[num_piv];
					unsigned * mm1 = new unsigned[num_piv];
					for (int j = 0; j < bplus->keysize; j++)
					{
						mm1[j] = 0;
						key1[num_piv + j - bplus->keysize] = node->entries[i]->min[j];
					}
					for (int j = bplus->keysize; j < num_piv; j++)
					{
						mm1[j] = 0;
						key1[j - bplus->keysize] = 0;
					}
					R_Hconvert(mm1, key1, num_piv);

					unsigned * key2 = new unsigned[num_piv];
					unsigned * mm2 = new unsigned[num_piv];
					for (int j = 0; j < bplus->keysize; j++)
					{
						mm2[j] = 0;
						key2[num_piv + j - bplus->keysize] = node->entries[i]->max[j];
					}
					for (int j = bplus->keysize; j < num_piv; j++)
					{
						mm2[j] = 0;
						key2[j - bplus->keysize] = 0;
					}
					R_Hconvert(mm2, key2, num_piv);
					delete[] key1;
					delete[] key2;
					int * m1 = new int[num_piv];
					int * m2 = new int[num_piv];
					for (int j = 0; j < num_piv; j++)
					{
						m1[j] = mm1[j];
						m2[j] = mm2[j];
					}
					delete[] mm1;
					delete[] mm2;
					kNNEntry entry;
					entry.edist = idist(dists, m1, m2);

					delete[] m1;
					delete[] m2;
					entry.level = node->level;
					entry.ptr = node->entries[i]->son;
					if (entry.edist*temp < kdist + addition)
					{
						queue.push(entry);
					}
				}
			}
			else
			{
				for (int i = 0; i < node->num_entries; i++)
				{
					unsigned * tem = new unsigned[num_piv];
					unsigned * key = new unsigned[num_piv];
					for (int j = 0; j < bplus->keysize; j++)
					{
						tem[j] = 0;
						key[j + num_piv - bplus->keysize] = node->entries[i]->key[j];
					}
					for (int j = bplus->keysize; j < num_piv; j++)
					{
						tem[j] = 0;
						key[j - bplus->keysize] = 0;
					}
					R_Hconvert(tem, key, num_piv);
					delete[] key;

					int d = edist(dists, tem);
					delete[] tem;
					if (d*temp < kdist + addition)
					{
						/*SortEntry se;
						Object* o = getobject(node->entries[i]->ptr);
						se.key = q->distance(*o);
						if (se.key <= kdist)
						{
							se.id = o->id;
							kNN.push_back(se);
							if (kNN.size() >= k)
							{
								sort(kNN.begin(), kNN.end());
								if (kNN.size() > k)
									kNN.pop_back();
								kdist = kNN.back().key;
							}
						}
						delete o;
						*/
						kNNEntry entry;
						entry.ptr = node->entries[i]->ptr;
						entry.level = 0;
						entry.edist = d;
						queue.push(entry);

					}

				}
			}
			delete node;
			bplus->root_ptr = node = NULL;
		}
		else  //pop a leaf entry and verify if it is a kNN
		{
			SortEntry se;
			Object* o = getobject(e.ptr);
			se.key = q->distance(*o);
			if (se.key <= kdist)
			{
				se.id = o->id;
				kNN.push_back(se);
				if (kNN.size() >= k)
				{
					sort(kNN.begin(), kNN.end());
					if (kNN.size() > k)
						kNN.pop_back();
					kdist = kNN.back().key;
				}
			}
			delete o;
		}
	}

	return kdist;
}

double PB_Tree::ImprovedkNN(Object * q, int k, int esti)
{
	int * dists = new int[num_piv]; 
	for(int i =0;i<num_piv;i++)
	{
		if(eps >0)
			dists[i] = (int) floor(q->distance(ptable[i])/eps);
		else
			dists[i]= (int) q->distance(ptable[i]);
	}
	int* qmin = new int[num_piv];
	int* qmax = new int[num_piv];
	
	for(int i =0;i<num_piv;i++)
	{
		qmin[i] = dists[i] - esti;
		qmax[i] = dists[i] + esti;
	}

	int addition =0;
	int temp;
	if(eps>0)
		temp = eps;
	else
		temp = 1;
	if(eps >0)
		addition = eps;
	
	vector<kNNEntry> * result = new vector <kNNEntry>;
	vector<B_Node *> * inodes =  new vector<B_Node *>;
	vector<B_Entry *> * ninodes = new vector<B_Entry *>;

	//Ƚа뾶Ϊestirange query
	bplus->load_root();
	H_kNNRRQ(bplus->root_ptr,inodes, ninodes, result, qmin, qmax, false); //************Hilbert
	delete bplus->root_ptr;
	bplus->root_ptr = NULL;
	//cout<<IOread<<endl;
	sort((*result).begin(), (*result).end());
	vector<SortEntry> kNN;
	double kdist =MAXREAL;
	for(int i =0;i<result->size();i++)
	{
		if((*result)[i].edist*temp>=kdist+addition)
		{
			delete[] qmin;
			delete[] qmax;
			delete[] dists;
			result->clear();
			delete result;
			for(int j =0;j<inodes->size();j++)
				delete (*inodes)[j];
			delete inodes;
			for(int j =0;j<ninodes->size();j++)
				(*ninodes)[j]->close();
			delete ninodes;
			return kdist;
		}
		else
		{
			SortEntry se;
			Object* o = getobject((*result)[i].ptr);
			se.key=q->distance(*o);
			if(se.key<=kdist)
			{
				se.id=o->id;
				kNN.push_back(se);
				if(kNN.size()>=k)
				{
					sort(kNN.begin(),kNN.end());
					if(kNN.size()>k)
						kNN.pop_back();
					kdist=kNN.back().key;
				}
			}
			delete o;
		}
	}
	result->clear();
	delete bplus->root_ptr;
    bplus->root_ptr=NULL;

	//Ӳѯ뾶


	vector<B_Entry *> * newninodes = NULL;
	vector<B_Node *> * newinodes = NULL;

	while(esti*temp<kdist+addition)
	{
		clear(inodes);
		esti+=1;
		for(int i =0;i<num_piv;i++)
		{
			qmin[i] = qmin[i] - 1;
			qmax[i] = qmax[i] + 1;
		}
		//ཻĽб
		newninodes = new vector<B_Entry *>;
		for(int i =0;i<ninodes->size();i++)
		{
			int t = determine(qmin, qmax, (*ninodes)[i]->mi, (*ninodes)[i]->ma);
			if(t==0)
			{
				processnode_H((*ninodes)[i]->get_son(), NULL, NULL, result, qmin, qmax, true,temp); //************Hilbert
				delete (*ninodes)[i]->get_son();
				(*ninodes)[i]->son_ptr = NULL;
			}
			else if(t>0)
			{
				if((*ninodes)[i]->level == 1)
				{
					(*ninodes)[i]->get_son()->min = (*ninodes)[i]->mi;
					(*ninodes)[i]->get_son()->max = (*ninodes)[i]->ma;
					(*ninodes)[i]->mi = (*ninodes)[i]->ma = NULL;
					processnode_H((*ninodes)[i]->get_son(), NULL, NULL, result, qmin, qmax, false,temp); //************Hilbert
					inodes->push_back((*ninodes)[i]->get_son());
					(*ninodes)[i]->son_ptr = NULL;
				}
				else
				{
					processnode_H((*ninodes)[i]->get_son(), inodes, newninodes, result, qmin, qmax, false,temp); //************Hilbert
					(*ninodes)[i]->del_son();
					(*ninodes)[i]->son_ptr = NULL;
				}
			}
			else
			{
				newninodes->push_back((*ninodes)[i]);
				(*ninodes)[i] = NULL;
			}
			if((*ninodes)[i]!=NULL)
			{
				(*ninodes)[i]->close();
				delete (*ninodes)[i];
				(*ninodes)[i] = NULL;
			}
		}
		//ཻб
		newinodes = new vector<B_Node *>;
		for(int i =0;i<inodes->size();i++)
		{
			int t = determine(qmin, qmax, (*inodes)[i]->min, (*inodes)[i]->max);
			if(t==0)
			{
				processnode_H((*inodes)[i], NULL, NULL, result, qmin, qmax, true, temp); //************Hilbert
				delete (*inodes)[i];
			}
			else if(t>0)
			{
				if((*inodes)[i]->level == 0)
				{
					processnode_H((*inodes)[i], NULL, NULL, result, qmin, qmax, false, temp); //************Hilbert
					newinodes->push_back((*inodes)[i]);
					(*inodes)[i]=NULL;
				}
				else
					processnode_H((*inodes)[i], newinodes, newninodes, result, qmin, qmax, false, temp); //************Hilbert

				if((*inodes)[i]!=NULL)
					delete (*inodes)[i];
				(*inodes)[i]=NULL;
			}
		}

		delete ninodes;
		ninodes = newninodes;
		newninodes = NULL;

		delete inodes;
		inodes = newinodes;
		newinodes = NULL;

		for(int i =0;i<result->size();i++)
		{
			if(esti*temp>=kdist+addition)
			{
				delete[] qmin;
				delete[] qmax;
				delete[] dists;
				delete result;
				for(int j =0;j<inodes->size();j++)
					delete (*inodes)[j];
				delete inodes;
				for(int j =0;j<ninodes->size();j++)
				{
					(*ninodes)[j]->close();
					delete (*ninodes)[j];
				}
				delete ninodes;
				return kdist;
			}
			else
			{
				SortEntry se;
				Object* o = getobject((*result)[i].ptr);
				se.key=q->distance(*o);
				if(se.key<=kdist)
				{
					se.id=o->id;
					kNN.push_back(se);
					if(kNN.size()>=k)
					{
						sort(kNN.begin(),kNN.end());
						if(kNN.size()>k)
							kNN.pop_back();
						kdist=kNN.back().key;
					}
				}
				delete o;
			}
		}
		result->clear();
	}
	

	delete result;
	for(int j =0;j<inodes->size();j++)
		delete (*inodes)[j];
	delete inodes;
	for(int j =0;j<ninodes->size();j++)
	{
		(*ninodes)[j]->close();
		delete (*ninodes)[j];
		(*ninodes)[j]= NULL;
	}
	delete ninodes;
	delete[] qmin;
	delete[] qmax;
	delete[] dists;
	return kdist;
		
}

// false: point is not in region [oqmin, oqmax]
// true: point is in region [oqmin, oqmax]
bool PB_Tree::inregion(int* point, int* oqmin, int* oqmax)
{
	for(int i =0;i<num_piv;i++)
	{
		if(point[i]<oqmin[i]||point[i]>oqmax[i])
			return false;
	}
	return true;
}

void PB_Tree::processnode(B_Node * node, vector<B_Node *> *inodes, vector<B_Entry *> * newninodes, vector<kNNEntry>* result, int* qmin, int* qmax, bool flag,int temp)
{
	if(node->level !=0)
	{
		if(flag)
		{
			for(int i =0;i<node->num_entries;i++)
			{
				processnode(node->entries[i]->get_son(),NULL, NULL, result, qmin, qmax, true,temp);
				node->entries[i]->del_son();
			}
		}
		else
		{
			for(int i =0;i<node->num_entries;i++)
			{
				int * m1 = R_Zconvert(node->entries[i]->min);
				int * m2 = R_Zconvert(node->entries[i]->max);
				int t = determine(qmin, qmax, m1, m2);
				if(t==0)
				{
					processnode(node->entries[i]->get_son(), NULL, NULL, result, qmin, qmax, true,temp);
					node->entries[i]->del_son();
				}
				else if(t>0)
				{	
					if(node->level == 1)
					{
						node->entries[i]->get_son()->min = m1;
						node->entries[i]->get_son()->max = m2;
						m1 = m2= NULL;
						processnode(node->entries[i]->get_son(), NULL, NULL, result, qmin, qmax, false,temp);
						inodes->push_back(node->entries[i]->get_son());
						node->entries[i]->son_ptr=NULL;
					}
					else
						processnode(node->entries[i]->get_son(), inodes, newninodes, result, qmin, qmax, false,temp);
					node->entries[i]->del_son();
				}
				else
				{
					node->entries[i]->mi= m1;					
					node->entries[i]->ma= m2;
					m1 = m2= NULL;
					newninodes->push_back(node->entries[i]);
					node->entries[i]= NULL;
				}
				if(m1!=NULL)
					delete[] m1;
				if(m2!=NULL)
					delete[] m2;
			}
		}
	}
	else
	{
		int radius = (qmax[0]-qmin[0])/2;
	//	cout<<"radius: "<<radius<<endl;
		int * query = new int[num_piv];
		for(int i =0;i<num_piv;i++) 
			query[i] = (qmax[i]+qmin[i])/2;
		
		if(flag)
		{
			for(int i =0;i<node->num_entries;i++)
			{
				kNNEntry entry;
				entry.ptr = node->entries[i]->ptr;
				result->push_back(entry);
			}
		}
		else
		{
			int* r1 = new int[num_piv];
			int* r2 = new int[num_piv];
			int * oqmin= new int[num_piv];
			int * oqmax = new int[num_piv];
			int r3;
			int r4;
			int count = 1;
			int incount = 1;
			for(int i =0;i<num_piv;i++)
			{
				oqmin[i]= qmin[i]+temp;
				oqmax[i]=qmax[i]-temp;

				if(qmin[i]<node->min[i])
					r1[i]=node->min[i];
				else
					r1[i]=qmin[i];

				if(r1[i]<0)
					r1[i]=0;

				if(qmax[i]<node->max[i])
					r2[i]=qmax[i];
				else
					r2[i]=node->max[i];
				if(r2[i]>MAXINT)
					r2[i]=MAXINT;

				if(oqmin[i]<node->min[i])
					r3=node->min[i];
				else
					r3=oqmin[i];

				if(r3<0)
					r3=0;

				if(oqmax[i]<node->max[i])
					r4=oqmax[i];
				else
					r4=node->max[i];
				if(r4>MAXINT)
					r4=MAXINT;
				count = count * (r2[i]-r1[i]+1);
				incount = incount * (r4-r3+1);
			}
			if(count-incount<node->num_entries)
			{
				vector<int> S;
				for(int i = r1[0];i<=r2[0];i++)
				{
					S.push_back(i);
				}

				vector<vector<int>> SS;
				vector<vector<int>> SS_t;
				int ** ss = new int* [count];
				for(int i =0;i<count;i++)
					ss[i]= new int[num_piv];

				for(int i =0;i<S.size();i++)
				{
					vector<int> s;
					s.push_back(S[i]);
					SS.push_back(s);
				}

				for(int k =0;k<num_piv-1;k++)
				{
					for(int i =0;i<SS.size();i++)
					{
						vector<int> s = SS[i];
						for(int j =r1[k+1];j<=r2[k+1];j++)
						{				
							s.push_back(j);
							SS_t.push_back(s);	
							s.pop_back();			
						}
					}
					SS.clear();
					SS = SS_t;
					SS_t.clear();
				}

				vector<IntArray> Z;

				for(int i=0;i<count;i++)
				{
					for(int j =0;j<num_piv;j++)
					{
						ss[i][j]=SS[i][j];	
						//cout<<ss[i][j]<<" ";
					}
					if(inregion(ss[i],oqmin,oqmax))
						continue;
					IntArray ia;
					ia.key = Zconvert(ss[i]);
					ia.keysize = bplus->keysize;
					Z.push_back(ia);						
					//	cout<<"&&&&&&&&:"<<dZ[i]<<endl;
				}
				S.clear();
				SS.clear();		
				sort(Z.begin(),Z.end());
				int j =0;
				vector<int> todelete;
				for(int i =0;i<Z.size()&&j<node->num_entries;)
				{					
					int temp = node->compareint(Z[i].key,node->entries[j]->key,bplus->keysize);
					if(temp==0)
					{
						kNNEntry entry;
						entry.ptr = node->entries[j]->ptr;
						result->push_back(entry);
						todelete.push_back(j);
						j++;
					}
					else if(temp<0)
					{
						i++;
					}
					else
					{
						j++;
					}
				}

				for(int i =todelete.size()-1;i>=0;i--)
				{
					node->rmv_entry_in_memory(todelete[i]);
				}

				for(int i =0;i<Z.size();i++)
					delete[] Z[i].key;
				Z.clear();
				todelete.clear();
				for(int i=0;i<count;i++)
					delete[] ss[i];
				delete[] ss;
				delete[] r1;
				delete[] r2;
				delete[] oqmin;
				delete[] oqmax;				
			}
			else
			{
				vector<int> todelete;
				for(int i =0;i<node->num_entries;i++)
				{
					int* tem = R_Zconvert(node->entries[i]->key);
					if(edist(tem, query)<=radius)
					{
						kNNEntry entry;
						entry.ptr = node->entries[i]->ptr;
						//cout<<"^^^^^^:"<<tt<<endl;
						result->push_back(entry);
						todelete.push_back(i);
					}
					delete[] tem;
				}
				for(int i = todelete.size()-1;i>=0;i--)
				{
					node->rmv_entry_in_memory(todelete[i]);
				}
				todelete.clear();
			}
		}
		delete[] query;
	}
}

void PB_Tree::processnode_H(B_Node * node, vector<B_Node *> *inodes, vector<B_Entry *> * newninodes, vector<kNNEntry>* result, int* qmin, int* qmax, bool flag,int temp)
{
	if(node->level !=0)
	{
		if(flag)
		{
			for(int i =0;i<node->num_entries;i++)
			{
				processnode_H(node->entries[i]->get_son(),NULL, NULL, result, qmin, qmax, true,temp);
				node->entries[i]->del_son();
			}
		}
		else
		{
			for(int i =0;i<node->num_entries;i++)
			{
				unsigned * key1 = new unsigned [num_piv];
				unsigned * mm1 = new unsigned [num_piv];
				for(int j =0;j<bplus->keysize;j++)
				{
					mm1[j]=0;
					key1[num_piv+j-bplus->keysize] = node->entries[i]->min[j];
				}
				for(int j = bplus->keysize;j<num_piv;j++)
				{
					mm1[j]=0;
					key1[j-bplus->keysize] = 0;
				}						
				R_Hconvert(mm1, key1, num_piv);

				unsigned * key2 = new unsigned [num_piv];
				unsigned * mm2 = new unsigned [num_piv];
				for(int j =0;j<bplus->keysize;j++)
				{
					mm2[j]=0;
					key2[num_piv+j-bplus->keysize] = node->entries[i]->max[j];
				}
				for(int j = bplus->keysize;j<num_piv;j++)
				{
					mm2[j]=0;
					key2[j-bplus->keysize] = 0;
				}						
				R_Hconvert(mm2, key2, num_piv);
				delete[] key1;
				delete[] key2;
				int * m1 = new int [num_piv];
				int * m2 = new int [num_piv];
				for(int j =0;j<num_piv;j++)
				{
					m1[j]= mm1[j];
					m2[j] = mm2[j];
				}
				delete[] mm1;
				delete[] mm2;

				int t = determine(qmin, qmax, m1, m2);
				if(t==0)
				{
					processnode_H(node->entries[i]->get_son(), NULL, NULL, result, qmin, qmax, true,temp);
					node->entries[i]->del_son();
				}
				else if(t>0)
				{	
					if(node->level == 1)
					{
						node->entries[i]->get_son()->min = m1;
						node->entries[i]->get_son()->max = m2;
						m1 = m2= NULL;
						processnode_H(node->entries[i]->get_son(), NULL, NULL, result, qmin, qmax, false,temp);
						inodes->push_back(node->entries[i]->get_son());
						node->entries[i]->son_ptr=NULL;
					}
					else
						processnode_H(node->entries[i]->get_son(), inodes, newninodes, result, qmin, qmax, false,temp);
					node->entries[i]->del_son();
				}
				else
				{
					node->entries[i]->mi= m1;					
					node->entries[i]->ma= m2;
					m1 = m2= NULL;
					newninodes->push_back(node->entries[i]);
					node->entries[i]= NULL;
				}
				if(m1!=NULL)
					delete[] m1;
				if(m2!=NULL)
					delete[] m2;
			}
		}
	}
	else
	{
		int radius = (qmax[0]-qmin[0])/2;
	//	cout<<"radius: "<<radius<<endl;
		int * query = new int[num_piv];
		for(int i =0;i<num_piv;i++) 
			query[i] = (qmax[i]+qmin[i])/2;
		
		if(flag)
		{
			for(int i =0;i<node->num_entries;i++)
			{
				kNNEntry entry;
				entry.ptr = node->entries[i]->ptr;
				result->push_back(entry);
			}
		}
		else
		{
			int* r1 = new int[num_piv];
			int* r2 = new int[num_piv];
			int * oqmin= new int[num_piv];
			int * oqmax = new int[num_piv];
			int r3;
			int r4;
			double count = 1;
			double incount = 1;
			for(int i =0;i<num_piv;i++)
			{
				oqmin[i]= qmin[i]+temp;
				oqmax[i]=qmax[i]-temp;

				if(qmin[i]<node->min[i])
					r1[i]=node->min[i];
				else
					r1[i]=qmin[i];

				if(r1[i]<0)
					r1[i]=0;

				if(qmax[i]<node->max[i])
					r2[i]=qmax[i];
				else
					r2[i]=node->max[i];
				if(r2[i]>MAXINT)
					r2[i]=MAXINT;

				if(oqmin[i]<node->min[i])
					r3=node->min[i];
				else
					r3=oqmin[i];

				if(r3<0)
					r3=0;

				if(oqmax[i]<node->max[i])
					r4=oqmax[i];
				else
					r4=node->max[i];
				if(r4>MAXINT)
					r4=MAXINT;
				count = count * (r2[i]-r1[i]+1);
				incount = incount * (r4-r3+1);
			}
			if((count-incount)<node->num_entries&&count<=100000)
			{
				vector<int> S;
				for(int i = r1[0];i<=r2[0];i++)
				{
					S.push_back(i);
				}

				vector<vector<int>> SS;
				vector<vector<int>> SS_t;
				int ** ss = new int* [count];
				for(int i =0;i<count;i++)
					ss[i]= new int[num_piv];

				for(int i =0;i<S.size();i++)
				{
					vector<int> s;
					s.push_back(S[i]);
					SS.push_back(s);
				}

				for(int k =0;k<num_piv-1;k++)
				{
					for(int i =0;i<SS.size();i++)
					{
						vector<int> s = SS[i];
						for(int j =r1[k+1];j<=r2[k+1];j++)
						{				
							s.push_back(j);
							SS_t.push_back(s);	
							s.pop_back();			
						}
					}
					SS.clear();
					SS = SS_t;
					SS_t.clear();
				}

				vector<IntArray> Z;

				for(int i=0;i<count;i++)
				{
					for(int j =0;j<num_piv;j++)
					{
						ss[i][j]=SS[i][j];	
						//cout<<ss[i][j]<<" ";
					}
					if(inregion(ss[i],oqmin,oqmax))
						continue;
					IntArray ia;
					unsigned *key = new unsigned [num_piv];
					Hconvert(key,(unsigned*) ss[i], num_piv);
					ia.key = new unsigned[bplus->keysize];
					for(int j =0;j<bplus->keysize;j++)
						ia.key[j] = key[j+num_piv-bplus->keysize];
					ia.keysize = bplus->keysize;
					delete[] key;
					Z.push_back(ia);
				}
				S.clear();
				SS.clear();		
				sort(Z.begin(),Z.end());
				int j =0;
				vector<int> todelete;
				for(int i =0;i<Z.size()&&j<node->num_entries;)
				{					
					int temp = node->compareint(Z[i].key,node->entries[j]->key,bplus->keysize);
					if(temp==0)
					{
						kNNEntry entry;
						entry.ptr = node->entries[j]->ptr;
						result->push_back(entry);
						todelete.push_back(j);
						j++;
					}
					else if(temp<0)
					{
						i++;
					}
					else
					{
						j++;
					}
				}

				for(int i =todelete.size()-1;i>=0;i--)
				{
					node->rmv_entry_in_memory(todelete[i]);
				}

				for(int i =0;i<Z.size();i++)
					delete[] Z[i].key;
				Z.clear();
				todelete.clear();
				for(int i=0;i<count;i++)
					delete[] ss[i];
				delete[] ss;
				delete[] r1;
				delete[] r2;
				delete[] oqmin;
				delete[] oqmax;				
			}
			else
			{
				vector<int> todelete;
				for(int i =0;i<node->num_entries;i++)
				{
					unsigned * temp = new unsigned [num_piv];
					unsigned * key = new unsigned [num_piv];
					for(int j =0;j<bplus->keysize;j++)
					{
						temp[j]=0;
						key[j+num_piv-bplus->keysize]= node->entries[i]->key[j];
					}
					for(int j=bplus->keysize;j<num_piv;j++)
					{
						temp[j]=0;
						key[j-bplus->keysize]=0;
					}
					R_Hconvert(temp, key, num_piv);
					delete[] key;

					if(edist(query, temp)<=radius)
					{
						kNNEntry entry;
						entry.ptr = node->entries[i]->ptr;
						//cout<<"^^^^^^:"<<tt<<endl;
						result->push_back(entry);
						todelete.push_back(i);
					}
					delete[] temp;
				}
				for(int i = todelete.size()-1;i>=0;i--)
				{
					node->rmv_entry_in_memory(todelete[i]);
				}
				todelete.clear();
			}
		}
		delete[] query;
	}
}

void PB_Tree::kNNQuery(Object * q, int k)
{
	int * dists = new int[num_piv]; 
	for(int i =0;i<num_piv;i++)
	{
		if(eps >0)
			dists[i] = (int) floor(q->distance(ptable[i])/eps);
		else
			dists[i]= (int) q->distance(ptable[i]);
	}
	
	int addition =0;
	int temp;
	if(eps>0)
		temp = eps;
	else
		temp = 1;
	if(eps >0)
		addition = eps;
	int t_rad =0;
	vector<SortEntry> kNN;
	int kdist =MAXREAL;
	bplus->load_root();
	while(t_rad*temp<kdist+addition)
	{
		//cout<<"*********************current radius: "<<t_rad<<"************************"<<endl;
		vector<int> S;
		S.push_back(0);
		for(int i = 1;i<=t_rad;i++)
		{
			S.push_back(i);
			S.push_back(0-i);
		}

		int s_size = pow(2.0*t_rad+1,num_piv);
		vector<vector<int>> SS;
		vector<vector<int>> SS_t;
		int ** ss = new int* [s_size];
		for(int i =0;i<s_size;i++)
			ss[i]= new int[num_piv];

		for(int i =0;i<S.size();i++)
		{
			vector<int> s;
			s.push_back(S[i]);
			SS.push_back(s);
		}

		for(int k =0;k<num_piv-1;k++)
		{
			for(int i =0;i<SS.size();i++)
			{
				vector<int> s = SS[i];
				for(int j =0;j<S.size();j++)
				{				
					s.push_back(S[j]);
					SS_t.push_back(s);	
					s.pop_back();			
				}
			}
			SS.clear();
			SS = SS_t;
			SS_t.clear();
		}


		for(int i=0;i<s_size;i++)
		{
			for(int j =0;j<num_piv;j++)
			{
				ss[i][j]=SS[i][j];
				//	cout<<ss[i][j]<<" ";
			}
			//cout<<endl;
		}
		S.clear();
		//SS.clear();

		vector<IntArray> Z;
		bool flag = false;
		bool flag2 = true;
		int * t_d =  new int[num_piv];
		for(int i=0;i<s_size;i++)
		{
			flag2 = true;
			flag = false;
			for(int j =0;j<num_piv;j++)
			{
				if(ss[i][j]>=t_rad||ss[i][j]<=0-t_rad)
					flag2 = false;
				ss[i][j]+= dists[j];
				t_d[j]=ss[i][j];
				if(ss[i][j]<0)
				{
					flag =  true;
					break;
				}
			}
			if(flag||flag2)
				continue;

			IntArray ia;
			ia.key = Zconvert(t_d);
			ia.keysize = bplus->keysize;
			Z.push_back(ia);
			//Z.push_back(Zconvert(t_d));
		}		
		delete[] t_d;
		for(int i=0;i<s_size;i++)
			delete[] ss[i];
		delete [] ss;
		sort(Z.begin(), Z.end());

	/*	for(int i=0;i<Z.size();i++)
			Z[i].print();*/
		
		vector<int> * result = new vector<int>;
		IntArray next;
		next.key = new unsigned[bplus->keysize];
		memcpy(next.key, Z[0].key,bplus->keysize*sizeof(int));
		next.keysize = bplus->keysize;
		int fla=1;
		
		for(int i =0;i<Z.size();i++)
		{
			if(fla ==0)
			{
				fla=1;
				continue;
			}
			if(fla == -1)
				break;
			if(next>Z[i])
				continue;
			else
			{
				fla=bplus->root_ptr->find_key(Z[i].key,next.key,result);
				//printf("%f next_key: %f %d\n",Z[i],next,result->size());
				if(result->size()>0)
				{
					Object * o= NULL;
					for(int j =0;j<result->size();j++)
					{
						SortEntry se;
						o = getobject((*result)[j]);
						se.key=q->distance(*o);
						if(se.key<=kdist)
						{
							se.id=o->id;
							kNN.push_back(se);
							if(kNN.size()>=k)
							{
								sort(kNN.begin(),kNN.end());
								if(kNN.size()>k)
									kNN.pop_back();
								kdist=kNN.back().key;
							}
							if(kdist<=t_rad*temp)
							{
								fla=-1;
								delete o;
								o=NULL;
								break;
							}
						}
						delete o;
						o=NULL;
					}
					result->clear();
				}
			}
		}
		for(int i=0;i<Z.size();i++)
			delete[] Z[i].key;
		delete[] next.key;
		Z.clear();
		delete result;		
		t_rad++;
	}
	delete bplus->root_ptr;
    bplus->root_ptr=NULL;
	delete[] dists;
}

void PB_Tree::kNNRRQ(B_Node* node, vector<B_Node *> *inodes, vector<B_Entry *> * ninodes, vector<kNNEntry>* result, int* qmin, int* qmax, bool flag)
{
	if(node->level !=0)
	{
		if(flag)
		{
			for(int i =0;i<node->num_entries;i++)
			{
				kNNRRQ(node->entries[i]->get_son(), NULL, NULL, result, qmin, qmax, true);
				node->entries[i]->del_son();
			}
		}
		else
		{
			for(int i =0;i<node->num_entries;i++)
			{
				int * m1 = R_Zconvert(node->entries[i]->min);
				int * m2 = R_Zconvert(node->entries[i]->max);
				int t = determine(qmin, qmax, m1, m2);
				if(t==0)
				{
					kNNRRQ(node->entries[i]->get_son(), NULL, NULL, result, qmin, qmax, true);
					node->entries[i]->del_son();
				}
				else if(t>0)
				{	
					if(node->level == 1)
					{
						node->entries[i]->get_son()->min = m1;
						node->entries[i]->son_ptr->max = m2;
						m1 = m2 = NULL;
						kNNRRQ(node->entries[i]->son_ptr, NULL, NULL, result, qmin, qmax, false);
						inodes->push_back(node->entries[i]->son_ptr);
						node->entries[i]->son_ptr=NULL;
					}
					else
						kNNRRQ(node->entries[i]->get_son(), inodes, ninodes, result, qmin, qmax, false);
					node->entries[i]->del_son();
				}
				else
				{
					node->entries[i]->mi= m1;					
					node->entries[i]->ma= m2;
					m1 = m2= NULL;
					ninodes->push_back(node->entries[i]);
					node->entries[i] = NULL;
				}
				if(m1!=NULL)
					delete[] m1;
				if(m2!=NULL)
					delete[] m2;
			}
		}
	}
	else
	{
		int radius = (qmax[0]-qmin[0])/2;
	//	cout<<"radius: "<<radius<<endl;
		int * query = new int[num_piv];
		for(int i =0;i<num_piv;i++) 
			query[i] = (qmax[i]+qmin[i])/2;
		
			if(flag)
			{
				for(int i =0;i<node->num_entries;i++)
				{
					kNNEntry entry;
					entry.ptr = node->entries[i]->ptr;
					int* temp = R_Zconvert(node->entries[i]->key);
					entry.edist = edist(query,temp);
				//	cout<<"***********:"<<entry.edist<<endl;
					delete[] temp;
					result->push_back(entry);
				}
			}
			else
			{
				int* r1 = new int[num_piv];
				int* r2 = new int[num_piv];
				double count = 1;
				for(int i =0;i<num_piv;i++)
				{
					if(qmin[i]<node->min[i])
						r1[i]=node->min[i];
					else
						r1[i]=qmin[i];
					if(r1[i]<0)
						r1[i]=0;

					if(qmax[i]<node->max[i])
						r2[i]=qmax[i];
					else
						r2[i]=node->max[i];
					if(r2[i]>MAXINT)
						r2[i]=MAXINT;
					//cout<<r1[i]<<" "<<r2[i]<<" ";
					count = count * (r2[i]-r1[i]+1);
				}
				//	cout<<endl;
				//	cout<<count<<endl;
				if(count<node->num_entries)
				{

					vector<vector<int>> SS;
					vector<vector<int>> SS_t;
					int ** ss = new int* [count];
					for(int i =0;i<count;i++)
						ss[i]= new int[num_piv];

					for(int i =r1[0];i<=r2[0];i++)
					{
						vector<int> s;
						s.push_back(i);
						SS.push_back(s);
					}

					for(int k =0;k<num_piv-1;k++)
					{
						for(int i =0;i<SS.size();i++)
						{
							vector<int> s = SS[i];
							for(int j =r1[k+1];j<=r2[k+1];j++)
							{				
								s.push_back(j);
								SS_t.push_back(s);	
								s.pop_back();			
							}
						}
						SS.clear();
						SS = SS_t;
						SS_t.clear();
					}

					vector<IntArray> Z;

					for(int i=0;i<count;i++)
					{
						for(int j =0;j<num_piv;j++)
						{
							ss[i][j]=SS[i][j];	
							//cout<<ss[i][j]<<" ";
						}

						IntArray ia;
						ia.edist = edist(ss[i],query);
						ia.key = Zconvert(ss[i]);
						ia.keysize = bplus->keysize;
						Z.push_back(ia);						
					//	cout<<"&&&&&&&&:"<<dZ[i]<<endl;
					}
					SS.clear();		
					sort(Z.begin(),Z.end());
					int j =0;
					vector<int> todelete;
					for(int i =0;i<count&&j<node->num_entries;)
					{					
						int temp = node->compareint(Z[i].key,node->entries[j]->key,bplus->keysize);
						if(temp==0)
						{
							kNNEntry entry;
							entry.ptr = node->entries[j]->ptr;
							entry.edist = Z[i].edist;
							result->push_back(entry);
							todelete.push_back(j);
							j++;
						}
						else if(temp<0)
						{
							i++;
						}
						else
						{
							j++;
						}
					}

					for(int i =todelete.size()-1;i>=0;i--)
					{
						node->rmv_entry_in_memory(todelete[i]);
					}

					for(int i =0;i<Z.size();i++)
						delete[] Z[i].key;
					Z.clear();
					todelete.clear();
					for(int i=0;i<count;i++)
						delete[] ss[i];
					delete[] ss;
					delete[] r1;
					delete[] r2;
				}
				else
				{
					vector<int> todelete;
					for(int i =0;i<node->num_entries;i++)
					{
						int* temp = R_Zconvert(node->entries[i]->key);
						int tt = edist(temp, query);
						if( tt<=radius)
						{
							kNNEntry entry;
							entry.ptr = node->entries[i]->ptr;
							entry.edist = tt;
							//cout<<"^^^^^^:"<<tt<<endl;
							result->push_back(entry);
							todelete.push_back(i);
						}
						delete[] temp;
					}
					for(int i =todelete.size()-1;i>=0;i--)
					{
						node->rmv_entry_in_memory(todelete[i]);
					}
					todelete.clear();
				}
			}
		delete[] query;
	}
}

void PB_Tree::H_kNNRRQ(B_Node* node, vector<B_Node *> *inodes, vector<B_Entry *> * ninodes, vector<kNNEntry>* result, int* qmin, int* qmax, bool flag)
{
	if(node->level !=0)
	{
		if(flag)
		{
			for(int i =0;i<node->num_entries;i++)
			{
				H_kNNRRQ(node->entries[i]->get_son(), NULL, NULL, result, qmin, qmax, true);
				node->entries[i]->del_son();
			}
		}
		else
		{
			for(int i =0;i<node->num_entries;i++)
			{
				unsigned * key1 = new unsigned [num_piv];
				unsigned * mm1 = new unsigned [num_piv];
				for(int j =0;j<bplus->keysize;j++)
				{
					mm1[j]=0;
					key1[num_piv+j-bplus->keysize] = node->entries[i]->min[j];
				}
				for(int j = bplus->keysize;j<num_piv;j++)
				{
					mm1[j]=0;
					key1[j-bplus->keysize] = 0;
				}						
				R_Hconvert(mm1, key1, num_piv);

				unsigned * key2 = new unsigned [num_piv];
				unsigned * mm2 = new unsigned [num_piv];
				for(int j =0;j<bplus->keysize;j++)
				{
					mm2[j]=0;
					key2[num_piv+j-bplus->keysize] = node->entries[i]->max[j];
				}
				for(int j = bplus->keysize;j<num_piv;j++)
				{
					mm2[j]=0;
					key2[j-bplus->keysize] = 0;
				}						
				R_Hconvert(mm2, key2, num_piv);
				delete[] key1;
				delete[] key2;
				int * m1 = new int [num_piv];
				int * m2 = new int [num_piv];
				for(int j =0;j<num_piv;j++)
				{
					m1[j]= mm1[j];
					m2[j] = mm2[j];
				}
				delete[] mm1;
				delete[] mm2;

				int t = determine(qmin, qmax, m1, m2);
				if(t==0)
				{
					H_kNNRRQ(node->entries[i]->get_son(), NULL, NULL, result, qmin, qmax, true);
					node->entries[i]->del_son();
				}
				else if(t>0)
				{	
					if(node->level == 1)
					{
						node->entries[i]->get_son()->min = m1;
						node->entries[i]->son_ptr->max = m2;
						m1 = m2 = NULL;
						H_kNNRRQ(node->entries[i]->son_ptr, NULL, NULL, result, qmin, qmax, false);
						inodes->push_back(node->entries[i]->son_ptr);
						node->entries[i]->son_ptr=NULL;
					}
					else
						H_kNNRRQ(node->entries[i]->get_son(), inodes, ninodes, result, qmin, qmax, false);
					node->entries[i]->del_son();
				}
				else
				{
					node->entries[i]->mi= m1;					
					node->entries[i]->ma= m2;
					m1 = m2= NULL;
					ninodes->push_back(node->entries[i]);
					node->entries[i] = NULL;
				}
				if(m1!=NULL)
					delete[] m1;
				if(m2!=NULL)
					delete[] m2;
			}
		}
	}
	else
	{
		int radius = (qmax[0]-qmin[0])/2;
	//	cout<<"radius: "<<radius<<endl;
		int * query = new int[num_piv];
		for(int i =0;i<num_piv;i++) 
			query[i] = (qmax[i]+qmin[i])/2;
		
			if(flag)
			{
				for(int i =0;i<node->num_entries;i++)
				{
					kNNEntry entry;
					entry.ptr = node->entries[i]->ptr;
					unsigned * temp = new unsigned [num_piv];
					unsigned * key = new unsigned [num_piv];
					for(int j =0;j<bplus->keysize;j++)
					{
						temp[j]=0;
						key[j+num_piv-bplus->keysize]= node->entries[i]->key[j];
					}
					for(int j=bplus->keysize;j<num_piv;j++)
					{
						temp[j]=0;
						key[j-bplus->keysize]=0;
					}
					R_Hconvert(temp, key, num_piv);
					delete[] key;
					entry.edist = edist(query,temp);
				//	cout<<"***********:"<<entry.edist<<endl;
					delete[] temp;
					result->push_back(entry);
				}
			}
			else
			{
				int* r1 = new int[num_piv];
				int* r2 = new int[num_piv];
				double count = 1;
				for(int i =0;i<num_piv;i++)
				{
					if(qmin[i]<node->min[i])
						r1[i]=node->min[i];
					else
						r1[i]=qmin[i];
					if(r1[i]<0)
						r1[i]=0;

					if(qmax[i]<node->max[i])
						r2[i]=qmax[i];
					else
						r2[i]=node->max[i];
					if(r2[i]>MAXINT)
						r2[i]=MAXINT;
					//cout<<r1[i]<<" "<<r2[i]<<" ";
					count = count * (r2[i]-r1[i]+1);
				}
				//	cout<<endl;
				//	cout<<count<<endl;
				if(count<node->num_entries)
				{
					vector<int> S;
					for(int i = r1[0];i<=r2[0];i++)
					{
						S.push_back(i);
					}

					vector<vector<int>> SS;
					vector<vector<int>> SS_t;
					int ** ss = new int* [count];
					for(int i =0;i<count;i++)
						ss[i]= new int[num_piv];

					for(int i =0;i<S.size();i++)
					{
						vector<int> s;
						s.push_back(S[i]);
						SS.push_back(s);
					}

					for(int k =0;k<num_piv-1;k++)
					{
						for(int i =0;i<SS.size();i++)
						{
							vector<int> s = SS[i];
							for(int j =r1[k+1];j<=r2[k+1];j++)
							{				
								s.push_back(j);
								SS_t.push_back(s);	
								s.pop_back();			
							}
						}
						SS.clear();
						SS = SS_t;
						SS_t.clear();
					}

					vector<IntArray> Z;

					for(int i=0;i<count;i++)
					{
						for(int j =0;j<num_piv;j++)
						{
							ss[i][j]=SS[i][j];	
							//cout<<ss[i][j]<<" ";
						}
						IntArray ia;
						ia.edist = edist(ss[i],query);
						unsigned *key = new unsigned [num_piv];
						Hconvert(key,(unsigned*) ss[i], num_piv);
						ia.key = new unsigned[bplus->keysize];
						for(int j =0;j<bplus->keysize;j++)
							ia.key[j] = key[j+num_piv-bplus->keysize];
						ia.keysize = bplus->keysize;
						delete[] key;
						Z.push_back(ia);						
					//	cout<<"&&&&&&&&:"<<dZ[i]<<endl;
					}
					S.clear();
					SS.clear();		
					sort(Z.begin(),Z.end());
					int j =0;
					vector<int> todelete;
					for(int i =0;i<count&&j<node->num_entries;)
					{					
						int temp = node->compareint(Z[i].key,node->entries[j]->key,bplus->keysize);
						if(temp==0)
						{
							kNNEntry entry;
							entry.ptr = node->entries[j]->ptr;
							entry.edist = Z[i].edist;
							result->push_back(entry);
							todelete.push_back(j);
							j++;
						}
						else if(temp<0)
						{
							i++;
						}
						else
						{
							j++;
						}
					}

					for(int i =todelete.size()-1;i>=0;i--)
					{
						node->rmv_entry_in_memory(todelete[i]);
					}

					for(int i =0;i<Z.size();i++)
						delete[] Z[i].key;
					Z.clear();
					todelete.clear();
					for(int i=0;i<count;i++)
						delete[] ss[i];
					delete[] ss;
					delete[] r1;
					delete[] r2;
				}
				else
				{
					vector<int> todelete;
					for(int i =0;i<node->num_entries;i++)
					{
						unsigned * temp = new unsigned [num_piv];
						unsigned * key = new unsigned [num_piv];
						for(int j =0;j<bplus->keysize;j++)
						{
							temp[j]=0;
							key[j+num_piv-bplus->keysize]= node->entries[i]->key[j];
						}
						for(int j=bplus->keysize;j<num_piv;j++)
						{
							temp[j]=0;
							key[j-bplus->keysize]=0;
						}
						R_Hconvert(temp, key, num_piv);
						delete[] key;
						int tt = edist(query, temp);
						if( tt<=radius)
						{
							kNNEntry entry;
							entry.ptr = node->entries[i]->ptr;
							entry.edist = tt;
							//cout<<"^^^^^^:"<<tt<<endl;
							result->push_back(entry);
							todelete.push_back(i);
						}
						delete[] temp;
					}
					for(int i =todelete.size()-1;i>=0;i--)
					{
						node->rmv_entry_in_memory(todelete[i]);
					}
					todelete.clear();
				}
			}
		delete[] query;
	}
}

int PB_Tree::edist(int * query, int* o)
{
	int ed = 0;
	int temp;
	for(int i =0;i<num_piv;i++)
	{
		temp= abs(query[i]-o[i]);
		if(temp>ed)
			ed = temp;
	}
	return ed;
}

int PB_Tree::edist(int * query, unsigned * o)
{
	int ed = 0;
	int temp;
	for(int i =0;i<num_piv;i++)
	{
		temp = o[i];
		temp= abs(query[i]-temp);
		if(temp>ed)
			ed = temp;
	}
	return ed;
}

// жMBRǷཻ: [min1, max1] ѯ[min2, max2]SPBڵMBR
// 0 
// -1 ཻ
// 1 ཻ
int PB_Tree::determine(int * min1, int * max1, int* min2, int* max2)
{
	int c1, c2, c3;
	c1= c2=c3=0;
	for(int i =0;i<num_piv;i++)
	{
		if(min2[i]>=min1[i]&&max2[i]<=max1[i])
			c1++;
		if(max2[i]<min1[i])
			return -1;
		if(min2[i]>max1[i])
			return -1;
	}
	if(c1 ==num_piv)
		return 0;
	return 1;
}


void PB_Tree::RRQ(B_Node* node, vector<int>* result, int* qmin, int* qmax, int* min, int *max, bool flag, vector<int> * tp)
{
	if(node->level !=0)
	{
		if(flag)
		{
			for(int i =0;i<node->num_entries;i++)
			{
				RRQ(node->entries[i]->get_son(), result, qmin, qmax, NULL, NULL, true, tp);
				node->entries[i]->del_son();
			}
		}
		else
		{
			for(int i =0;i<node->num_entries;i++)
			{
				int * m1 = R_Zconvert(node->entries[i]->min);
				int * m2 = R_Zconvert(node->entries[i]->max);
				int t = determine(qmin, qmax, m1, m2);
				if(t==0)
				{
					RRQ(node->entries[i]->get_son(), result, qmin, qmax, NULL, NULL, true, tp);
					node->entries[i]->del_son();
				}
				else if(t>0)
				{	
					if(node->level == 1)
						RRQ(node->entries[i]->get_son(), result, qmin, qmax, m1, m2, false, tp);
					else
						RRQ(node->entries[i]->get_son(), result, qmin, qmax, NULL, NULL, false, tp);
					node->entries[i]->del_son();
				}
				delete[] m1;
				delete[] m2;
			}
		}
	}
	else
	{
		int radius = (qmax[0]-qmin[0])/2;
		int * query = new int[num_piv];
		for(int i =0;i<num_piv;i++) 
			query[i] = (qmax[i]+qmin[i])/2;
		if(tp->size()>0)
		{
			int* tpdists = new int[num_piv];
			for(int i=0;i<tp->size();i++)
				tpdists[(*tp)[i]]= radius - query[(*tp)[i]];
			if(flag)
			{
				bool fdelete;
				for(int i =0;i<node->num_entries;i++)
				{
					fdelete = false;
					int* z = R_Zconvert(node->entries[i]->key);
					for(int j=0;i<tp->size();j++)
					{
						if(z[(*tp)[j]]<=tpdists[(*tp)[j]])
						{
							fdelete = true;
							break;
						}
					}
					delete[] z;
					if(fdelete)
						continue;
					result->push_back(node->entries[i]->ptr);
				}
			}
			else
			{
				int* r1 = new int[num_piv];
				int* r2 = new int[num_piv];
				int count = 1;
				int m =0;
				for(int i =0;i<num_piv;i++)
				{
					if(qmin[i]<min[i])
						r1[i]=min[i];
					else
						r1[i]=qmin[i];
					if(r1[i]<0)
						r1[i]=0;
					if((*tp)[m]== i)
					{
						if(min[i]<tpdists[i])
							min[i] = tpdists[i];
						m++;
					}
					if(qmax[i]<max[i])
						r2[i]=qmax[i];
					else
						r2[i]=max[i];
					if(r2[i]>MAXINT)
						r2[i]= MAXINT;

					//cout<<r1[i]<<" "<<r2[i]<<" ";
					count = count * (r2[i]-r1[i]+1);
				}
				//	cout<<endl;
				//	cout<<count<<endl;

				if(count<node->num_entries)
				{
					vector<int> S;
					for(int i = r1[0];i<=r2[0];i++)
					{
						S.push_back(i);
					}

					vector<vector<int>> SS;
					vector<vector<int>> SS_t;
					int ** ss = new int* [count];
					for(int i =0;i<count;i++)
						ss[i]= new int[num_piv];

					for(int i =0;i<S.size();i++)
					{
						vector<int> s;
						s.push_back(S[i]);
						SS.push_back(s);
					}

					for(int k =0;k<num_piv-1;k++)
					{
						for(int i =0;i<SS.size();i++)
						{
							vector<int> s = SS[i];
							for(int j =r1[k+1];j<=r2[k+1];j++)
							{				
								s.push_back(j);
								SS_t.push_back(s);	
								s.pop_back();			
							}
						}
						SS.clear();
						SS = SS_t;
						SS_t.clear();
					}

					vector<IntArray> Z;
					for(int i=0;i<count;i++)
					{
						for(int j =0;j<num_piv;j++)
						{
							ss[i][j]=SS[i][j];						
							//	cout<<ss[i][j]<<" ";
						}
						IntArray ia;
						ia.key = Zconvert(ss[i]);
						ia.keysize = bplus->keysize;
						Z.push_back(ia);
						//	cout<<endl;
					}
					S.clear();
					SS.clear();		
					sort(Z.begin(),Z.end());
					int j =0;
					for(int i =0;i<count&&j<node->num_entries;)
					{					
						int temp = node->compareint(Z[i].key,node->entries[j]->key,bplus->keysize);
						if(temp==0)
						{
							result->push_back(node->entries[j]->ptr);
							j++;
						}
						else if(temp<0)
						{
							i++;
						}
						else
						{
							j++;
						}
					}

					for(int i =0;i<Z.size();i++)
						delete[] Z[i].key;
					Z.clear();
					for(int i=0;i<count;i++)
						delete[] ss[i];
					delete[] ss;
					delete[] r1;
					delete[] r2;

				}
				else
				{
								
					bool fdelete;
					for(int i =0;i<node->num_entries;i++)
					{
						fdelete = false;
						int* temp = R_Zconvert(node->entries[i]->key);
						for(int j =0;j<tp->size();j++)
						{
							if(temp[(*tp)[j]]<=tpdists[(*tp)[j]])
							{
								fdelete = true;
								break;
							}
						}
						if(fdelete)
						{
							delete[] temp;
							continue;
						}
						if(edist(temp, query) <=radius)
							result->push_back(node->entries[i]->ptr);
						delete[] temp;
					}				
				}
			}
			delete[] tpdists;
		}
		else
		{
			if(flag)
			{
				for(int i =0;i<node->num_entries;i++)
					result->push_back(node->entries[i]->ptr);
			}
			else
			{
				int* r1 = new int[num_piv];
				int* r2 = new int[num_piv];
				int count = 1;
				for(int i =0;i<num_piv;i++)
				{
					if(qmin[i]<min[i])
						r1[i]=min[i];
					else
						r1[i]=qmin[i];
					if(r1[i]<0)
						r1[i]=0;
					if(qmax[i]<max[i])
						r2[i]=qmax[i];
					else
						r2[i]=max[i];
					if(r2[i]>MAXINT)
						r2[i]= MAXINT;
					//cout<<r1[i]<<" "<<r2[i]<<" ";
					count = count * (r2[i]-r1[i]+1);
				}
				//	cout<<endl;
				//	cout<<count<<endl;

				if(count<node->num_entries)
				{
					vector<int> S;
					for(int i = r1[0];i<=r2[0];i++)
					{
						S.push_back(i);
					}

					vector<vector<int>> SS;
					vector<vector<int>> SS_t;
					int ** ss = new int* [count];
					for(int i =0;i<count;i++)
						ss[i]= new int[num_piv];

					for(int i =0;i<S.size();i++)
					{
						vector<int> s;
						s.push_back(S[i]);
						SS.push_back(s);
					}

					for(int k =0;k<num_piv-1;k++)
					{
						for(int i =0;i<SS.size();i++)
						{
							vector<int> s = SS[i];
							for(int j =r1[k+1];j<=r2[k+1];j++)
							{				
								s.push_back(j);
								SS_t.push_back(s);	
								s.pop_back();			
							}
						}
						SS.clear();
						SS = SS_t;
						SS_t.clear();
					}

					vector<IntArray> Z;
					for(int i=0;i<count;i++)
					{
						for(int j =0;j<num_piv;j++)
						{
							ss[i][j]=SS[i][j];						
							//	cout<<ss[i][j]<<" ";
						}
						IntArray ia;
						ia.key = Zconvert(ss[i]);
						ia.keysize = bplus->keysize;
						Z.push_back(ia);
						//	cout<<endl;
					}
					S.clear();
					SS.clear();		
					sort(Z.begin(),Z.end());
					int j =0;
					for(int i =0;i<count&&j<node->num_entries;)
					{					
						int temp = node->compareint(Z[i].key,node->entries[j]->key,bplus->keysize);
						if(temp==0)
						{
							result->push_back(node->entries[j]->ptr);
							j++;
						}
						else if(temp<0)
						{
							i++;
						}
						else
						{
							j++;
						}
					}

					for(int i =0;i<Z.size();i++)
						delete[] Z[i].key;
					Z.clear();
					for(int i=0;i<count;i++)
						delete[] ss[i];
					delete[] ss;
					delete[] r1;
					delete[] r2;

				}
				else
				{

					for(int i =0;i<num_piv;i++)
						query[i] = (qmax[i]+qmin[i])/2;
					for(int i =0;i<node->num_entries;i++)
					{
						int* temp = R_Zconvert(node->entries[i]->key);
						if(edist(temp, query) <=radius)
							result->push_back(node->entries[i]->ptr);
						delete[] temp;
					}				
				}
			}
		}
		delete[] query;
	}
}

void PB_Tree::RRQH(B_Node* node, vector<int>* result, int* qmin, int* qmax, int* min, int *max, bool flag, vector<int> * tp)
{
	if(node->level !=0)
	{
		if(flag)
		{
			for(int i =0;i<node->num_entries;i++)
			{
				RRQH(node->entries[i]->get_son(), result, qmin, qmax, NULL, NULL, true, tp);
				node->entries[i]->del_son();
			}
		}
		else
		{
			for(int i =0;i<node->num_entries;i++)
			{
				//int * m1 = R_Zconvert(node->entries[i]->min);
				//int * m2 = R_Zconvert(node->entries[i]->max);
				unsigned * key1 = new unsigned [num_piv];
				unsigned * mm1 = new unsigned [num_piv];
				for(int j =0;j<bplus->keysize;j++)
				{
					mm1[j]=0;
					key1[num_piv+j-bplus->keysize] = node->entries[i]->min[j];
				}
				for(int j = bplus->keysize;j<num_piv;j++)
				{
					mm1[j]=0;
					key1[j-bplus->keysize] = 0;
				}						
				R_Hconvert(mm1, key1, num_piv);

				unsigned * key2 = new unsigned [num_piv];
				unsigned * mm2 = new unsigned [num_piv];
				for(int j =0;j<bplus->keysize;j++)
				{
					mm2[j]=0;
					key2[num_piv+j-bplus->keysize] = node->entries[i]->max[j];
				}
				for(int j = bplus->keysize;j<num_piv;j++)
				{
					mm2[j]=0;
					key2[j-bplus->keysize] = 0;
				}						
				R_Hconvert(mm2, key2, num_piv);
				delete[] key1;
				delete[] key2;
				int * m1 = new int [num_piv];
				int * m2 = new int [num_piv];
				for(int j =0;j<num_piv;j++)
				{
					m1[j]= mm1[j];
					m2[j] = mm2[j];
				}
				delete[] mm1;
				delete[] mm2;

				int t = determine(qmin, qmax, m1, m2);
				if(t==0)
				{
					RRQH(node->entries[i]->get_son(), result, qmin, qmax, NULL, NULL, true, tp);
					node->entries[i]->del_son();
				}
				else if(t>0)
				{	
					if(node->level == 1)
						RRQH(node->entries[i]->get_son(), result, qmin, qmax, m1, m2, false, tp);
					else
						RRQH(node->entries[i]->get_son(), result, qmin, qmax, NULL, NULL, false, tp);
					node->entries[i]->del_son();
				}
				delete[] m1;
				delete[] m2;
			}
		}
	}
	else
	{
		int radius = (qmax[0]-qmin[0])/2;
		int * query = new int[num_piv];
		for(int i =0;i<num_piv;i++) 
			query[i] = (qmax[i]+qmin[i])/2;
		int tt =0;
		if(eps>0)
			tt = 1;
		if(tp->size()>0)
		{
			int* tpdists = new int[num_piv];
			for(int i=0;i<tp->size();i++)
				tpdists[(*tp)[i]]= radius - query[(*tp)[i]]-tt;
			if(flag)
			{
				bool fdelete;
				for(int i =0;i<node->num_entries;i++)
				{
					fdelete = false;
					unsigned * key = new unsigned [num_piv];
					unsigned * z = new unsigned [num_piv];
					for(int j =0;j<bplus->keysize;j++)
					{
						z[j]=0;
						key[j+num_piv-bplus->keysize] = node->entries[i]->key[j];
					}
					for(int j = bplus->keysize;j<num_piv;j++)
					{
						z[j]=0;
						key[j-bplus->keysize] = 0;
					}						
					R_Hconvert(z, key, num_piv);
					delete[] key;

					for(int j=0;j<tp->size();j++)
					{
						if(z[(*tp)[j]]<=tpdists[(*tp)[j]])
						{
							fdelete = true;
							break;
						}
					}
					delete[] z;
					if(fdelete)
						continue;
					result->push_back(node->entries[i]->ptr);
				}
			}
			else
			{
				int* r1 = new int[num_piv];
				int* r2 = new int[num_piv];
				double count = 1;
				int m =0;
				for(int i =0;i<num_piv;i++)
				{
					if(qmin[i]<min[i])
						r1[i]=min[i];
					else
						r1[i]=qmin[i];
					if(r1[i]<0)
						r1[i]=0;
					if((*tp)[m]== i)
					{
						if(min[i]<tpdists[i])
							min[i] = tpdists[i];
						m++;
					}
					if(qmax[i]<max[i])
						r2[i]=qmax[i];
					else
						r2[i]=max[i];
					if(r2[i]>MAXINT)
						r2[i]= MAXINT;

					//cout<<r1[i]<<" "<<r2[i]<<" ";
					count = count * (r2[i]-r1[i]+1);
				}
				//	cout<<endl;
				//	cout<<count<<endl;

				if(count<node->num_entries)
				{
					vector<int> S;
					for(int i = r1[0];i<=r2[0];i++)
					{
						S.push_back(i);
					}

					vector<vector<int>> SS;
					vector<vector<int>> SS_t;
					int ** ss = new int* [count];
					for(int i =0;i<count;i++)
						ss[i]= new int[num_piv];

					for(int i =0;i<S.size();i++)
					{
						vector<int> s;
						s.push_back(S[i]);
						SS.push_back(s);
					}

					for(int k =0;k<num_piv-1;k++)
					{
						for(int i =0;i<SS.size();i++)
						{
							vector<int> s = SS[i];
							for(int j =r1[k+1];j<=r2[k+1];j++)
							{				
								s.push_back(j);
								SS_t.push_back(s);	
								s.pop_back();			
							}
						}
						SS.clear();
						SS = SS_t;
						SS_t.clear();
					}

					vector<IntArray> Z;
					for(int i=0;i<count;i++)
					{
						for(int j =0;j<num_piv;j++)
						{
							ss[i][j]=SS[i][j];						
							//	cout<<ss[i][j]<<" ";
						}
						IntArray ia;
						unsigned *key = new unsigned [num_piv];
						Hconvert(key,(unsigned*) ss[i], num_piv);
						ia.key = new unsigned[bplus->keysize];
						for(int j =0;j<bplus->keysize;j++)
							ia.key[j] = key[j+num_piv-bplus->keysize];
						ia.keysize = bplus->keysize;
						delete[] key;
						Z.push_back(ia);
						//	cout<<endl;
					}
					S.clear();
					SS.clear();		
					sort(Z.begin(),Z.end());
					int j =0;
					for(int i =0;i<count&&j<node->num_entries;)
					{					
						int temp = node->compareint(Z[i].key,node->entries[j]->key,bplus->keysize);
						if(temp==0)
						{
							result->push_back(node->entries[j]->ptr);
							j++;
						}
						else if(temp<0)
						{
							i++;
						}
						else
						{
							j++;
						}
					}

					for(int i =0;i<Z.size();i++)
						delete[] Z[i].key;
					Z.clear();
					for(int i=0;i<count;i++)
						delete[] ss[i];
					delete[] ss;
					delete[] r1;
					delete[] r2;

				}
				else
				{
								
					bool fdelete;
					for(int i =0;i<node->num_entries;i++)
					{
						fdelete = false;
						unsigned * temp = new unsigned [num_piv];
						unsigned * key = new unsigned [num_piv];
						for(int j =0;j<bplus->keysize;j++)
						{
							temp[j]=0;
							key[j+num_piv-bplus->keysize]= node->entries[i]->key[j];
						}
						for(int j=bplus->keysize;j<num_piv;j++)
						{
							temp[j]=0;
							key[j-bplus->keysize]=0;
						}
						R_Hconvert(temp, key, num_piv);
						delete[] key;

						for(int j =0;j<tp->size();j++)
						{
							if(temp[(*tp)[j]]<=tpdists[(*tp)[j]])
							{
								fdelete = true;
								break;
							}
						}
						if(fdelete)
						{
							delete[] temp;
							continue;
						}
						if(edist(query,temp) <=radius)
							result->push_back(node->entries[i]->ptr);
						delete[] temp;
					}				
				}
			}
			delete[] tpdists;
		}
		else
		{
			if(flag)
			{
				for(int i =0;i<node->num_entries;i++)
					result->push_back(node->entries[i]->ptr);
			}
			else
			{
				int* r1 = new int[num_piv];
				int* r2 = new int[num_piv];
				double count = 1;
				for(int i =0;i<num_piv;i++)
				{
					if(qmin[i]<min[i])
						r1[i]=min[i];
					else
						r1[i]=qmin[i];
					if(r1[i]<0)
						r1[i]=0;
					if(qmax[i]<max[i])
						r2[i]=qmax[i];
					else
						r2[i]=max[i];
					if(r2[i]>MAXINT)
						r2[i]= MAXINT;
					//cout<<r1[i]<<" "<<r2[i]<<" ";
					count = count * (r2[i]-r1[i]+1);
				}
				//	cout<<endl;
				//	cout<<count<<endl;

				if(count<node->num_entries)
				{
					vector<int> S;
					for(int i = r1[0];i<=r2[0];i++)
					{
						S.push_back(i);
					}

					vector<vector<int>> SS;
					vector<vector<int>> SS_t;
					int ** ss = new int* [count];
					for(int i =0;i<count;i++)
						ss[i]= new int[num_piv];

					for(int i =0;i<S.size();i++)
					{
						vector<int> s;
						s.push_back(S[i]);
						SS.push_back(s);
					}

					for(int k =0;k<num_piv-1;k++)
					{
						for(int i =0;i<SS.size();i++)
						{
							vector<int> s = SS[i];
							for(int j =r1[k+1];j<=r2[k+1];j++)
							{				
								s.push_back(j);
								SS_t.push_back(s);	
								s.pop_back();			
							}
						}
						SS.clear();
						SS = SS_t;
						SS_t.clear();
					}

					vector<IntArray> Z;
					for(int i=0;i<count;i++)
					{
						for(int j =0;j<num_piv;j++)
						{
							ss[i][j]=SS[i][j];						
							//	cout<<ss[i][j]<<" ";
						}
						IntArray ia;
						unsigned *key = new unsigned [num_piv];
						Hconvert(key, (unsigned *) ss[i], num_piv);
						ia.key = new unsigned[bplus->keysize];
						for(int j =0;j<bplus->keysize;j++)
							ia.key[j] = key[num_piv-bplus->keysize+j];
						ia.keysize = bplus->keysize;
						delete[] key;
						Z.push_back(ia);
						//	cout<<endl;
					}
					S.clear();
					SS.clear();		
					sort(Z.begin(),Z.end());
					int j =0;
					for(int i =0;i<count&&j<node->num_entries;)
					{					
						int temp = node->compareint(Z[i].key,node->entries[j]->key,bplus->keysize);
						if(temp==0)
						{
							result->push_back(node->entries[j]->ptr);
							j++;
						}
						else if(temp<0)
						{
							i++;
						}
						else
						{
							j++;
						}
					}

					for(int i =0;i<Z.size();i++)
						delete[] Z[i].key;
					Z.clear();
					for(int i=0;i<count;i++)
						delete[] ss[i];
					delete[] ss;
					delete[] r1;
					delete[] r2;

				}
				else
				{
					for(int i =0;i<node->num_entries;i++)
					{
						unsigned * key = new unsigned [num_piv];
						unsigned * temp = new unsigned [num_piv];
						for(int j =0;j<bplus->keysize;j++)
						{
							temp[j]=0;
							key[j+num_piv-bplus->keysize] = node->entries[i]->key[j];
						}
						for(int j = bplus->keysize;j<num_piv;j++)
						{
							temp[j]=0;
							key[j-bplus->keysize] = 0;
						}						
						R_Hconvert(temp, key, num_piv);
						if(edist(query, temp) <=radius)
							result->push_back(node->entries[i]->ptr);
						delete[] temp;
						delete[] key;
					}				
				}
			}
		}
		delete[] query;
	}
}

void PB_Tree::ImprovedRQ(Object * q, double radius)
{
	int * dists = new int[num_piv]; 
	double* tpdists= new double[num_piv];
	vector<int> tp;
	for(int i =0;i<num_piv;i++)
	{
		tpdists[i] = q->distance(ptable[i]);

		if(eps>0)
			dists[i] = (int) floor(tpdists[i]/eps);
		else
			dists[i] = (int) tpdists[i];
		tpdists[i] -= radius;
		if(eps>0)
			tpdists[i] = floor(tpdists[i]/eps);
		if(tpdists[i]<=0)
			tp.push_back(i);
	}
//	printf("%f\n",Zconvert(dists));
	int t_rad;
	if(eps>0)
		t_rad = (int) ceil(radius/eps) + 1;
	else
		t_rad = (int) radius;

	int* qmin = new int[num_piv];
	int* qmax = new int[num_piv];

	for(int i =0;i<num_piv;i++)
	{
		qmin[i] = dists[i] - t_rad;
		qmax[i] = dists[i] + t_rad;
	}

	bplus->load_root();
	vector<int> * result = new vector<int>;
	//*********************************************************Space Filling curve**************************
	RRQH(bplus->root_ptr,result, qmin, qmax, NULL, NULL, false, &tp);
	delete[] qmin;
	delete[] qmax;
	delete[] dists;
	vector<int> RQ;

	Object * o= NULL;
	for(int j =0;j<result->size();j++)
	{
		o = getobject((*result)[j]);
		if(q->distance(*o)<=radius)
		{
			RQ.push_back(o->id);						
		}
		delete o;
	}
	result->clear();
	delete result;
	delete[] tpdists;
	delete bplus->root_ptr;
	bplus->root_ptr=NULL;
	//print the result id
	//cout<<"***********************result:"<<RQ.size()<<"*********************"<<endl;
	//for(int i =0;i<RQ.size();i++)
	//	cout<<RQ[i]<<" ";
	//cout<<endl;
	//cout<<"***************************************************"<<endl;
}

void PB_Tree::RangeQuery(Object * q, double radius)
{
	int * dists = new int[num_piv]; 
	double* tpdists= new double[num_piv];
	vector<int> tp;
	for(int i =0;i<num_piv;i++)
	{
		tpdists [i] = q->distance(ptable[i]);

		if(eps>0)
			dists[i] = (int) floor(tpdists[i]/eps);
		else
			dists[i] = (int) tpdists[i];
		tpdists[i] -= radius;
		if(eps>0)
			tpdists[i] = floor(tpdists[i]/eps);
		if(tpdists[i]<=0)
			tp.push_back(i);
		/*if(eps >0)
			dists[i] = (int) floor(q->distance(ptable[i])/eps);
		else
			dists[i]= (int) q->distance(ptable[i]);*/
	}
//	printf("%f\n",Zconvert(dists));
	int t_rad;
	if(eps>0)
		t_rad = (int) ceil(radius/eps) + 1;
	else
		t_rad = (int) radius;

	vector<int> S;
	S.push_back(0);
	for(int i = 1;i<=t_rad;i++)
	{
		S.push_back(i);
		S.push_back(0-i);
	}

	int s_size = pow(2.0*t_rad+1,num_piv);
	vector<vector<int>> SS;
	vector<vector<int>> SS_t;
	int ** ss = new int* [s_size];
	for(int i =0;i<s_size;i++)
		ss[i]= new int[num_piv];

	for(int i =0;i<S.size();i++)
	{
		vector<int> s;
		s.push_back(S[i]);
		SS.push_back(s);
	}

	for(int k =0;k<num_piv-1;k++)
	{
		for(int i =0;i<SS.size();i++)
		{
			vector<int> s = SS[i];
			for(int j =0;j<S.size();j++)
			{				
				s.push_back(S[j]);
				SS_t.push_back(s);	
				s.pop_back();			
			}
		}
		SS.clear();
		SS = SS_t;
		SS_t.clear();
	}

	
	for(int i=0;i<s_size;i++)
	{
		
		for(int j =0;j<num_piv;j++)
		{
			ss[i][j]=SS[i][j];
		//	cout<<ss[i][j]<<" ";
		}
		//cout<<endl;
	}
	S.clear();
	SS.clear();
	
	vector<IntArray> Z;
	bool flag = false;
	int * t_d =  new int[num_piv];
	for(int i=0;i<s_size;i++)
	{
		flag = false;
		for(int j =0;j<num_piv;j++)
		{
			ss[i][j]+= dists[j];
			t_d[j]=ss[i][j];
			if(ss[i][j]<0||ss[i][j]>MAXINT)
			{
				flag =  true;
				break;
			}
		}
		if(flag)
			continue;
		
		IntArray ia;
		ia.key = Zconvert(t_d);
		ia.keysize = bplus->keysize;
		Z.push_back(ia);
	}

	sort(Z.begin(), Z.end());
	for(int i=0;i<s_size;i++)
		delete[] ss[i];
	delete[] ss;
	delete[] t_d;
	delete[] dists;
	//for(int i =0;i<Z.size();i++)
	//	Z[i].print();

	bplus->load_root();
	vector<int> * result = new vector<int>;
	vector<int> RQ;

	IntArray next;
	next.key = new unsigned [bplus->keysize];
	memcpy(next.key,Z[0].key,bplus->keysize*sizeof(int));
	next.keysize = bplus->keysize;
	int fla = 1;
	for(int i =0;i<Z.size();i++)
	{
		if(fla ==0)
		{
			fla = 1;
			continue;
		}
		if(fla == -1)
			break;
		if(next>Z[i])
			continue;
		else
		{

			fla=bplus->root_ptr->find_key(Z[i].key,next.key, result);
			//cout<<"fla: "<<fla<<" ";
			//cout<<"search: "; Z[i].print();
			//cout<<"next: "; next.print();
			//cout<<" resultset: "<<result->size()<<endl;
			if(result->size()>0)
			{
				if(tp.size()>0)
				{
					int * rz =  R_Zconvert(Z[i].key);
					for(int i=0;i<tp.size();i++)
					{
						Object * o= NULL;
						//cout<<rz[tp[i]]<<"&"<<tpdists[tp[i]]<<endl;
						if(rz[tp[i]]<=-tpdists[tp[i]])
						{						
							/*for(int j =0;j<result->size();j++)
							{
								o = getobject((*result)[j]);
								RQ.push_back(o->id);
							    delete o;
							}*/
							result->clear();
							break;
						}
					}
					delete[] rz;
				}
				Object * o= NULL;
				for(int j =0;j<result->size();j++)
				{
					o = getobject((*result)[j]);
					if(q->distance(*o)<=radius)
					{
						RQ.push_back(o->id);						
					}
					delete o;
				}
				result->clear();
			}
		}
	}
	cc+=RQ.size();
	delete result;
	delete bplus->root_ptr;
	bplus->root_ptr=NULL;
	delete[] next.key;
	for(int i =0;i<Z.size();i++)
		delete[] Z[i].key;
	Z.clear();

	//print the result id
	cout<<"***********************result:"<<RQ.size()<<"*********************"<<endl;
	for(int i =0;i<RQ.size();i++)
		cout<<RQ[i]<<" ";
	cout<<endl;
	cout<<"***************************************************"<<endl;
}

Object* PB_Tree::getobject(int ptr)
{
	int i = ptr/draf->file->blocklength  ;
	char * buffer = new char[draf->file->blocklength];

	if(c==NULL)
	{
		draf->file->read_block(buffer,i);
	}
	else
	{
		c->read_block(buffer,i,draf);
	}

	int j = ptr- i*draf->file->blocklength;
	Object* o = new Object();
	o->read_from_buffer(&buffer[j]);

	delete[] buffer;
	//printf("%d %d %f\n",o->id, o->size, o->data[0]);

	return o;
}
